#include <stdio.h>
#include <bits/stdc++.h>

#define X first
#define Y second
#define all(v) v.begin(), v.end()
#define SZ(v) (int)(v.size())
#define pb push_back

using namespace std;

typedef pair<int, int> ii;
typedef long long ll;

const int INF = 100000000;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
  //  freopen("input.txt", "r", stdin);
    int n, m;
    cin>>n>>m;
    char a[n][m];
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
            cin>>a[i][j];
    int u[26][n][m];
    int d[26][n][m];
    int l[26][n][m];
    int r[26][n][m];
    for(int c=0; c<26; c++) {
        for(int i=0; i<n; i++)
            for(int j=0; j<m; j++) {
                l[c][i][j]=u[c][i][j]=INF;
                if(j&&a[i][j-1]==c+'a')l[c][i][j]=1;
                else if(j&&l[c][i][j-1]<INF)l[c][i][j]=l[c][i][j-1]+1;
                if(i&&a[i-1][j]==c+'a')u[c][i][j]=1;
                else if(i&&u[c][i-1][j]<INF)u[c][i][j]=u[c][i-1][j]+1;
            }
        for(int i=n-1; i>=0; i--)
            for(int j=m-1; j>=0; j--) {
                r[c][i][j]=d[c][i][j]=INF;
                if(j<m-1&&a[i][j+1]==c+'a')r[c][i][j]=1;
                else if(j<m-1&&r[c][i][j+1]<INF)r[c][i][j]=r[c][i][j+1]+1;
                if(i<n-1&&a[i+1][j]==c+'a')d[c][i][j]=1;
                else if(i<n-1&&d[c][i+1][j]<INF)d[c][i][j]=d[c][i+1][j]+1;
            }
    }
    int q; cin>>q;
    while(q--) {
        int I,J;
        cin>>I>>J;
        --I; --J;
        int dist=INF;
        int p1,q1=J,p2=I,q2;
        for(int c1=0; c1<26; c1++)
            if(min(u[c1][I][J],d[c1][I][J])<INF)
                for(char c2=0; c2<26; c2++)
                    if(min(l[c2][I][J],r[c2][I][J])<INF&&c1!=c2) {
                        if(u[c1][I][J]+l[c2][I][J]<dist) {
                            dist=u[c1][I][J]+l[c2][I][J];
                            p1=I-u[c1][I][J];
                            q2=J-l[c2][I][J];
                        }
                        if(u[c1][I][J]+r[c2][I][J]<dist) {
                            dist=u[c1][I][J]+r[c2][I][J];
                            p1=I-u[c1][I][J];
                            q2=J+r[c2][I][J];
                        }
                        if(d[c1][I][J]+l[c2][I][J]<dist) {
                            dist=d[c1][I][J]+l[c2][I][J];
                            p1=I+d[c1][I][J];
                            q2=J-l[c2][I][J];
                        }
                        if(d[c1][I][J]+r[c2][I][J]<dist) {
                            dist=d[c1][I][J]+r[c2][I][J];
                            p1=I+d[c1][I][J];
                            q2=J+r[c2][I][J];
                        }
                    }
        if(dist<INF)cout<<p1+1<<' '<<q1+1<<' '<<p2+1<<' '<<q2+1<<"\n";
        else cout<<-1<<"\n";
    }
    return 0;
}
