#include <bits/stdc++.h>

using namespace std;

#define y1 y123456789

const int inf = (int)1e8;

int n, m, q, x, y;

int main() {
	scanf("%d %d", &n, &m);

	char c[n + 2][m + 2];
	int d[n + 2][m + 2][27];
	int u[n + 2][m + 2][27];
	int l[n + 2][m + 2][27];
	int r[n + 2][m + 2][27];

	memset(d, -1, sizeof(d));
	memset(u, -1, sizeof(u));
	memset(l, -1, sizeof(l));
	memset(r, -1, sizeof(r));

	for (int i = 1; i <= n; ++i)
		scanf("%s", c[i] + 1);

	for (int i = 1; i <= n; ++i) {
		for (int j = 1; j <= m; ++j) {
			for (int k = 1; k <= 26; ++k) {
				if (i > 1 && c[i - 1][j] - 'a' + 1 == k)
					u[i][j][k] = i - 1;
				else
					u[i][j][k] = u[i - 1][j][k];
				if (j > 1 && c[i][j - 1] - 'a' + 1 == k)
					l[i][j][k] = j - 1;
				else
					l[i][j][k] = l[i][j - 1][k];
			}	
		}
	}

	for (int i = n; i >= 1; --i) {
		for (int j = m; j >= 1; --j) {
			for (int k = 1; k <= 26; ++k) {
				if (i < n && c[i + 1][j] - 'a' + 1 == k)
					d[i][j][k] = i + 1;
				else
					d[i][j][k] = d[i + 1][j][k];
				if (j < m && c[i][j + 1] - 'a' + 1 == k)
					r[i][j][k] = j + 1;
				else
					r[i][j][k] = r[i][j + 1][k];
			}	
		}
	}

	scanf("%d", &q);

	while (q--) {
		scanf("%d %d", &x, &y);
		int ans = inf, x1, y1, x2, y2;
		for (int k1 = 1; k1 <= 26; k1++) {
			for (int k2 = 1; k2 <= 26; k2++) {
				if (k1 == k2)
					continue;
				if (u[x][y][k1] != -1 && l[x][y][k2] != -1 && abs(x - u[x][y][k1]) + abs(y - l[x][y][k2]) < ans) {
					ans = abs(x - u[x][y][k1]) + abs(y - l[x][y][k2]);
					x1 = u[x][y][k1];
					y1 = y;
					x2 = x;
					y2 = l[x][y][k2];
				}
				if (u[x][y][k1] != -1 && r[x][y][k2] != -1 && abs(x - u[x][y][k1]) + abs(y - r[x][y][k2]) < ans) {
					ans = abs(x - u[x][y][k1]) + abs(y - r[x][y][k2]);
					x1 = u[x][y][k1];
					y1 = y;
					x2 = x;
					y2 = r[x][y][k2];
				}
				if (d[x][y][k1] != -1 && l[x][y][k2] != -1 && abs(x - d[x][y][k1]) + abs(y - l[x][y][k2]) < ans) {
					ans = abs(x - d[x][y][k1]) + abs(y - l[x][y][k2]);
					x1 = d[x][y][k1];
					y1 = y;
					x2 = x;
					y2 = l[x][y][k2];
				}
				if (d[x][y][k1] != -1 && r[x][y][k2] != -1 && abs(x - d[x][y][k1]) + abs(y - r[x][y][k2]) < ans) {
					ans = abs(x - d[x][y][k1]) + abs(y - r[x][y][k2]);
					x1 = d[x][y][k1];
					y1 = y;
					x2 = x;
					y2 = r[x][y][k2];
				}
			}
		}
		if (ans == inf)
			printf("-1\n");
		else 
			printf("%d %d %d %d\n", x1, y1, x2, y2);
	}

	return 0;
}