#include <bits/stdc++.h>
using namespace std;

const int MAX_N = 2e6;

int n;
int go[MAX_N][26];
int cnt = 1;
string q[MAX_N];
vector<int> last;
unordered_set<int> ss[MAX_N][26];
bool term[MAX_N];
int pos[MAX_N];

void push(int v, int id, string& s, int k) {
    if (id == s.size()) {
        last.push_back(k);
        return;
    }
    if (term[v]) {
        push(1, id, s, k);
    } else {
        if (go[v][s[id] - 'a'] != 0) {
            push(go[v][s[id] - 'a'], id + 1, s, k);
            pos[k]++;
        } else {
            ss[v][s[id] - 'a'].insert(k);
        }
    }
}


void add(int v, int id, string& s) {
    if (id == s.size()) {
        term[v] = 1;
        vector<int> topush;
        for (int c = 0; c < 26; c++) {
            for (int u : ss[v][c]) {
                ss[1][c].insert(u);
                topush.push_back(u);
            }
            ss[v][c].clear();
        }
        for (int i : topush) {
            push(1, pos[i], q[i], i);
        }
        return;
    }
    if (go[v][s[id] - 'a'] == 0) {
        cnt++;
        go[v][s[id] - 'a'] = cnt;
        for (int u : ss[v][s[id] - 'a']) {
            if (pos[u] + 1 == q[u].size()) {
                last.push_back(u);
            } else {
                int nx = q[u][pos[u] + 1] - 'a';
                ss[cnt][nx].insert(u);
                pos[u]++;
            }
        }
        ss[v][s[id] - 'a'].clear();
        add(cnt, id + 1, s);
    } else {
        add(go[v][s[id] - 'a'], id + 1, s);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    int r = 1;
    int shift = 0;
    for (int i = 0; i < n; i++) {
        string s, t;
        cin >> s >> t;
        shift %= t.size();
        t = t + t;
        t = t.substr(shift, t.size() / 2);
        last.resize(0);
        if (s == "+") {
            add(1, 0, t);
        } else {
            q[r] = t;
            push(1, 0, t, r);
            r++;
        }
        cout << last.size() << " ";
        for (int i : last) {
            cout << i << " ";
        }
        shift = last.size();
        cout << "\n";
    }
    return 0;
}
