#ifdef _DEBUG
# include <iostream>
# include <algorithm>
# include <vector>
# include <string>
#else
#include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
#endif

  int n, k, m;
  cin >> n >> k >> m;

  vector<int> d(m);
  for (int i = 0; i < m; i++)
	cin >> d[i];

  sort(d.begin(), d.end());

  vector<int> a(m);
  int p = m;
  for (int i = m - 1; i >= 0; i--)
  {
	while (p > 0 && d[p - 1] - d[i] >= k)
	  p--;

	a[i] = p;
  }

  int max = 0;

  if (d[m - 1] < k)
	max = n - d[m - 1];

  for (int i = 0; i < m && (i == 0 || d[i - 1] < k); i++)
  {
	int sum = 0, p = i;

	while (p != m)
	  if (a[p] != m)
	  {
		sum += k;
		p = a[p];
	  }
	  else
	  {
		sum += min(n - d[p] + 1, k);
		p = a[p];
	  }

	if (i != 0)
	  sum += d[i - 1];

	if (n - sum > max)
	  max = n - sum;
  }

  cout << max << endl;
}