#include<bits/stdc++.h>

using namespace std;


const int MAXN = 500001;
int n, m;
string s[MAXN];
vector<int> last[4][26][MAXN];
int dx[4] = {0, 0, 1, -1};
int dy[4] = {1, -1, 0, 0};


int main() {
    ios::sync_with_stdio(false);
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    for (int k = 0; k < 4; k++) {
        for (int t = 0; t < 26; t++) {
            for (int i = 0; i < n; i++) {
                last[k][t][i].resize(m);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int t = 0; t < 26; t++) {
                last[0][t][i][j] = -1;
                if (j) {
                    last[0][t][i][j] = last[0][t][i][j - 1];
                    if (s[i][j - 1] - 'a' == t) {
                        last[0][t][i][j] = j - 1;
                    }
                }
                last[2][t][i][j] = -1;
                if (i) {
                    last[2][t][i][j] = last[2][t][i - 1][j];
                    if (s[i - 1][j] - 'a' == t) {
                        last[2][t][i][j] = i - 1;
                    }
                }
            }
        }
        for (int j = m - 1; j >= 0; j--) {
            for (int t = 0; t < 26; t++) {
                last[1][t][i][j] = -1;
                if (j < m - 1) {
                    last[1][t][i][j] = last[1][t][i][j + 1];
                    if (s[i][j + 1] - 'a' == t) {
                        last[1][t][i][j] = j + 1;
                    }
                }
            }
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j = 0; j < m; j++) {
            for (int t = 0; t < 26; t++) {
                last[3][t][i][j] = -1;
                if (i < n - 1) {
                    last[3][t][i][j] = last[3][t][i + 1][j];
                    if (s[i + 1][j] - 'a' == t) {
                        last[3][t][i][j] = i + 1;
                    }
                }
            }
        }
    }
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int x, y;
        cin >> x >> y;
        x--, y--;
        vector<int> v;
        for (int k = 0; k < 4; k++) {
            int x2 = x + dx[k];
            int y2 = y + dy[k];
            if (x2 < 0 || y2 < 0 || x2 >= n || y2 >= m) {
                continue;
            }
            v.push_back(s[x2][y2] - 'a');
        }
        int ans = 1000000000;
        pair<int, int> al, ar;
        for (auto t: v) {
            int f = -1;
            if (last[0][t][x][y] != -1) {
                f = last[0][t][x][y];
            }
            int f1 = last[1][t][x][y];
            if (f1 != -1) {
                if (f == -1) {
                    f = f1;
                } else {
                    if (y - f > f1 - y) {
                        f = f1;
                    }
                }
            }
            if (f == -1) {
                continue;
            }
            for (int t1 = 0; t1 < 26; t1++) {
                if (t == t1) {
                    continue;
                }
                int ff = -1;
                if (last[2][t1][x][y] != -1) {
                    ff = last[2][t1][x][y];
                }
                int ff1 = last[3][t1][x][y];
                if (ff1 != -1) {
                    if (ff == -1) {
                        ff = ff1;
                    } else {
                        if (x - ff > ff1 - x) {
                            ff = ff1;
                        }
                    }
                }
                if (ff == -1) {
                    continue;
                }
                pair<int, int> a = make_pair(x, f);
                pair<int, int> b = make_pair(ff, y);
                int dist = abs(a.first - b.first) + abs(a.second - b.second);
                if (ans > dist) {
                    ans = dist;
                    al = a;
                    ar = b;
                }
            }
        }
        for (auto t: v) {
            int f = -1;
            if (last[2][t][x][y] != -1) {
                f = last[2][t][x][y];
            }
            int f1 = last[3][t][x][y];
            if (f1 != -1) {
                if (f == -1) {
                    f = f1;
                } else {
                    if (x - f > f1 - x) {
                        f = f1;
                    }
                }
            }
            if (f == -1) {
                continue;
            }
            for (int t1 = 0; t1 < 26; t1++) {
                if (t == t1) {
                    continue;
                }
                int ff = -1;
                if (last[0][t1][x][y] != -1) {
                    ff = last[0][t1][x][y];
                }
                int ff1 = last[1][t1][x][y];
                if (ff1 != -1) {
                    if (ff == -1) {
                        ff = ff1;
                    } else {
                        if (y - ff > ff1 - y) {
                            ff = ff1;
                        }
                    }
                }
                if (ff == -1) {
                    continue;
                }
                pair<int, int> a = make_pair(f, y);
                pair<int, int> b = make_pair(x, ff);
                int dist = abs(a.first - b.first) + abs(a.second - b.second);
                if (ans > dist) {
                    ans = dist;
                    al = a;
                    ar = b;
                }
            }
        }
        if (ans == 1000000000) {
            cout << -1 << endl;
        } else {
            cout << al.first + 1 << ' ' << al.second + 1 << ' ' << ar.first + 1 << ' ' << ar.second + 1 << endl;
        }
    }
    return 0;
}
