#include<bits/stdc++.h>

using namespace std;

int n, k;
int cnt1[301];
int cnt2[301][301];
bool used[301];
int dist[301];
vector <int> clr[301];
int ans[301][301];

int get(int u) {
    for (int j = 0; j < k; ++j) {
        dist[j] = n + 1;
        used[j] = false;
    }
    dist[u] = cnt1[u];
    while (true) {
        int d = n + 1, v = -1;
        for (int j = 0; j < k; ++j) {
            if (used[j])
                continue;
            if (d > dist[j]) {
                d = dist[j];
                v = j;
            }
        }
        if (v == -1) break;
        used[v] = true;
        for (int j = 0; j < k; ++j) {
            if (cnt2[v][j] == 0)
                continue;
            dist[j] = min(dist[j], dist[v] + cnt1[j] - cnt2[v][j]);
        }
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin >> n >> k;
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;
        for (int j = 0; j < m; ++j) {
            int a;
            cin >> a;
            --a;
            cnt1[a]++;
            for (int b: clr[i]) {
                cnt2[b][a]++;
                cnt2[a][b]++;
            }
            clr[i].push_back(a);
        }
    }
    for (int i = 0; i < k; ++i) {
        get(i);
        for (int j = 0; j < n; ++j) {
            ans[j][i] = n + 1;
            for (int q: clr[j]) {
                ans[j][i] = min(ans[j][i], dist[q]);
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (j == i) {
                cout << 0 << ' ';
                continue;
            }
            int res = n + 1;
            for (int q: clr[i]) {
                res = min(res, ans[j][q]);
            }
            if (res == n + 1)
                res = -1;
            cout << res << ' ';
        }
        cout << '\n';
    }
}
