import java.io.*;
import java.util.*;

public class B {
//    String fileName = "<name>";

    public void solve() throws IOException {
        int m = nextInt();
        m = nextInt();
        int k = nextInt();
        Pair[] people = new Pair[k * 2];
        for (int i = 0; i < k; i++) {
            people[2 * i] = new Pair(nextInt(), 1, i);
            people[2 * i + 1] = new Pair(nextInt(), -1, i);
        }
        Arrays.sort(people, new Comparator<Pair>() {
            @Override
            public int compare(Pair o1, Pair o2) {
                if (o1.in - o2.in != 0)
                    return o1.in - o2.in;
                else if (o1.type - o2.type != 0)
                    return o1.type - o2.type;
                else
                    return o1.number - o2.number;
            }
        });
        int yk = 0;
        int svsid = m - 1;
        int svstep = m;
        long mas[] = new long[m];
        TreeSet<Integer> peupl = new TreeSet<>();
        for (int i = 1; i < m * 2 + 1; i++) {
            peupl.add(i);
        }
        int pr[] = new int[k];
        for (int i = 0; i < 2 * k; i++) {
            if (people[i].type == 1) {
                int s = peupl.first();
                if (s == 2 * m) {
//                    pr[people[i].number]=true;
                    pr[people[i].number] = s;
                } else if (s < m) {
                    svsid--;
                    pr[people[i].number] = s;
                    peupl.remove(s);
                } else {
                    peupl.remove(s);
                    mas[s - m] -= people[i].in;
                    pr[people[i].number] = s;
                    yk++;
                }
            } else {
                if (pr[people[i].number] != 2 * m) {
                    peupl.add(pr[people[i].number]);
                    if (pr[people[i].number] >= m)
                        mas[pr[people[i].number]-m] += people[i].in;
                }
            }
        }
        int ind = 0;
        for (int i = 1; i < m; i++) {
//            System.out.print(mas[i] + " ");
            if (mas[i] < mas[ind]) {
                ind = i;
            }
        }
        System.out.println(mas[ind] + " " + (ind + 1));
    }

    class Pair {
        int in;
        int type;

        public Pair(int in, int type, int number) {
            this.in = in;
            this.type = type;
            this.number = number;
        }

        int number;

    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}