#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>

using namespace std;

struct vert{
	int l, r, u, d;
};

vector< vector<char> > arr;

int n, m;

bool ok(int a, int b, int c, int d){
	if (a < 0 || b < 0 || c < 0 || d < 0)
		return 0;
	if (a >= n || c >= n || b >= m || d >= m)
		return 0;
	return(arr[a][b] != arr[c][d]);

}

int main() {
	ios_base::sync_with_stdio(false);
	cin >> n >> m;
	arr.resize(n, vector<char>(m));
	for (int i = 0; i < n; i++){
		for (int j = 0; j < m; j++){
			cin >> arr[i][j];
		}
	}
	vector< vector< vert > > dp(n, vector< vert >(m));
	for (int i = 0; i < n; i++){
		for (int j = 0; j < m; j++){
			if (i && arr[i - 1][j] == arr[i][j])
				dp[i][j].u = dp[i - 1][j].u + 1;
			if (j && arr[i][j - 1] == arr[i][j])
				dp[i][j].l = dp[i][j - 1].l + 1;
		}
	}
	for (int i = n - 1; i >= 0; i--){
		for (int j = m - 1; j >= 0; j--){
			if (i != n - 1 && arr[i + 1][j] == arr[i][j])
				dp[i][j].d = dp[i + 1][j].d + 1;
			if (j != m - 1 && arr[i][j + 1] == arr[i][j])
				dp[i][j].r = dp[i][j + 1].r + 1;
		}
	}
	int q;
	cin >> q;
	while (q--){
		int x, y;
		cin >> x >> y;
		x--; y--;
		if (ok(x - 1, y, x, y - 1)){
			x++;
			y++;
			cout << x - 1 << ' ' << y << ' ' << x << ' ' << y - 1 << '\n';
			continue;
		}
		if (ok(x + 1, y, x, y - 1)){
			x++;
			y++;
			cout << x + 1 << ' ' << y << ' ' << x << ' ' << y - 1 << '\n';
			continue;
		}
		if (ok(x + 1, y, x, y + 1)){
			x++;
			y++;
			cout << x + 1 << ' ' << y << ' ' << x << ' ' << y + 1 << '\n';
			continue;
		}
		if (ok(x - 1, y, x, y + 1)){
			x++;
			y++;
			cout << x - 1 << ' ' << y << ' ' << x << ' ' << y + 1 << '\n';
			continue;
		}
		int mn = 1e9;
		pair< pair<int, int>, pair<int, int> > ans;
		if (x - 1 >= 0){
			if (x - 1 - dp[x - 1][y].u - 1 >= 0){
				if (dp[x - 1][y].u < mn){
					mn = dp[x - 1][y].u;
					ans = { { x - 1 - dp[x - 1][y].u - 1, y }, { x, y + 1 } };
				}
			}
		}
		if (x + 1 < n){
			if (x + 1 + dp[x + 1][y].d + 1 < n){
				if (dp[x + 1][y].d < mn){
					mn = dp[x + 1][y].d;
					ans = { { x + 1 + dp[x + 1][y].d + 1, y }, { x, y + 1 } };
				}
			}
		}
		if (y - 1 >= 0){
			if (y - 1 - dp[x][y - 1].l - 1 >= 0){
				if (dp[x][y - 1].l < mn){
					mn = dp[x][y - 1].l;
					ans = { { x, y - 1 - dp[x][y - 1].l - 1 }, { x + 1, y } };
				}
			}
		}
		if (y + 1 < m){
			if (y + 1 + dp[x][y + 1].r + 1 < m){
				if (dp[x][y + 1].r < mn){
					mn = dp[x][y + 1].r;
					ans = { { x, y + 1 + dp[x][y + 1].r + 1 }, { x + 1, y } };
				}
			}
		}
		if (ans.second.first >= n)
			ans.second.first -= 2;
		if (ans.second.second >= m)
			ans.second.second -= 2;
		if (mn == 1e9)
			cout << -1 << '\n';
		else{
			cout << ans.first.first + 1 << ' ' << ans.first.second + 1 << ' ' << ans.second.first + 1 << ' ' << ans.second.second + 1 << '\n';
		}
	}
	return 0;
}
