#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<string> s;
vector< vector<int> > d[4][26], z[4][26];

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    s.resize(n);
    getline(cin, s[0]);
    for (int i = 0; i < n; i++)
        getline(cin, s[i]);
    for (int i = 0; i < 4; i++)
        for (int j = 0; j < 26; j++)
        {
            d[i][j].resize(n, vector<int>(m, -1));
            z[i][j].resize(n, vector<int>(m, -1));
        }
    for (int t = 0; t < 26; t++)
    {
        for (int i = 0; i < n; i++)
        {
            int last = -1, beg = -3;
            for (int j = 0; j < m; j++)
            {
                d[0][t][i][j] = last;
                z[0][t][i][j] = beg;
                if (s[i][j] - 'a' != t)
                    beg = j;
                if (s[i][j] - 'a' == t)
                    last = j;
            }
        }
    }
    for (int t = 0; t < 26; t++)
    {
        for (int i = 0; i < n; i++)
        {
            int last = -1, beg = -3;
            for (int j = m - 1; j >= 0; j--)
            {
                d[1][t][i][j] = last;
                z[1][t][i][j] = beg;
                if (s[i][j] - 'a' != t)
                    beg = j;
                if (s[i][j] - 'a' == t)
                    last = j;
            }
        }
    }
    for (int t = 0; t < 26; t++)
    {
        for (int i = 0; i < m; i++)
        {
            int last = -1, beg = -3;
            for (int j = 0; j < n; j++)
            {
                d[2][t][j][i] = last;
                z[2][t][j][i] = beg;
                if (s[j][i] - 'a' != t)
                    beg = j;
                if (s[j][i] - 'a' == t)
                    last = j;
            }
        }
    }
   for (int t = 0; t < 26; t++)
    {
        for (int i = 0; i < m; i++)
        {
            int last = -1, beg = -3;
            for (int j = n - 1; j >= 0; j--)
            {
                d[3][t][j][i] = last;
                z[3][t][j][i] = beg;
                if (s[j][i] - 'a' != t)
                    beg = j;
                if (s[j][i] - 'a' == t)
                    last = j;
            }
        }
    }
    int q;
    cin >> q;
    for (int ui = 0; ui < q; ui++)
    {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        int ans = 1e9, v1 = -1, v2, u1, u2;
        for (int b = 0; b < 26; b++)
        {
            if (d[0][b][x][y] >= 0)
            {
                if (x > 0 && s[x - 1][y] - 'a' != b && ans > abs(y - d[0][b][x][y]) + 1)
                {
                    ans = abs(y - d[0][b][x][y]) + 1;
                    v1 = x;
                    v2 = d[0][b][x][y];
                    u1 = x - 1;
                    u2 = y;
                }
                if (x < n - 1 && s[x + 1][y] - 'a' != b && ans > abs(y - d[0][b][x][y]) + 1)
                {
                    ans = abs(y - d[0][b][x][y]) + 1;
                    v1 = x;
                    v2 = d[0][b][x][y];
                    u1 = x + 1;
                    u2 = y;
                }
                if (z[2][b][x][y] >= 0 && ans > abs(x - z[2][b][x][y]) + abs(d[0][b][x][y] - y))
                {
                    ans = abs(x - z[2][b][x][y]) + abs(d[0][b][x][y] - y);
                    v1 = x;
                    v2 = d[0][b][x][y];
                    u1 = z[2][b][x][y];
                    u2 = y;
                }
                if (z[2][b][x][y] >= 0 && ans > abs(x - z[3][b][x][y]) + abs(d[0][b][x][y] - y))
                {
                    ans = abs(x - z[3][b][x][y]) + abs(d[0][b][x][y] - y);
                    v1 = x;
                    v2 = d[0][b][x][y];
                    u1 = z[3][b][x][y];
                    u2 = y;
                }
            }
            if (d[1][b][x][y] >= 0)
            {
                if (x > 0 && s[x - 1][y] - 'a' != b && ans > abs(y - d[1][b][x][y]) + 1)
                {
                    ans = abs(y - d[1][b][x][y]) + 1;
                    v1 = x;
                    v2 = d[1][b][x][y];
                    u1 = x - 1;
                    u2 = y;
                }
                if (x < n - 1 && s[x + 1][y] - 'a' != b && ans > abs(y - d[1][b][x][y]) + 1)
                {
                    ans = abs(y - d[1][b][x][y]) + 1;
                    v1 = x;
                    v2 = d[1][b][x][y];
                    u1 = x + 1;
                    u2 = y;
                }
                if (z[2][b][x][y] >= 0 && ans > abs(x - z[2][b][x][y]) + abs(d[1][b][x][y] - y))
                {
                    ans = abs(x - z[2][b][x][y]) + abs(d[1][b][x][y] - y);
                    v1 = x;
                    v2 = d[1][b][x][y];
                    u1 = z[2][b][x][y];
                    u2 = y;
                }
                if (z[2][b][x][y] >= 0 && ans > abs(x - z[3][b][x][y]) + abs(d[1][b][x][y] - y))
                {
                    ans = abs(x - z[3][b][x][y]) + abs(d[1][b][x][y] - y);
                    v1 = x;
                    v2 = d[1][b][x][y];
                    u1 = z[3][b][x][y];
                    u2 = y;
                }
            }
        }
        if (v1 == -1)
            cout << -1 << endl;
        else
            cout << v1 + 1 << " " << v2 + 1 << " " << u1 + 1 << " " << u2 + 1 << endl;
    }
    return 0;
}
