#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;

const int N = (int) 4e5 + 123;

int run() {
	ll t;
	cin >> t;
	for (int q = 0; q < t; q++) {
		ll a, n;
		cin >> a >> n;
		ll t1 = a - (a%n);
		ll t2 = a + (n - (a%n));
		ll b1 = a ^ t1;
		ll b2 = a ^ t2;
		cout << min(b1, b2) << "\n";
	}
	return 0;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}