#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define rep(i, l, r) for (int i = l; i < r; i++)

using namespace std;

void print(vector<int> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;
}



const int INF = (int)1e9 + 7;
int kek = 26;




int main()
{
    //freopen("a.in", "r", stdin);
    /*ios_base::sync_with_stdio(0);
    cin.tie(0);*/
    int n, m;
    scanf("%d%d", &n, &m);
    vector<vector<vector<pair<int, int> > > > gor(n, vector<vector<pair<int, int> > > (m, vector<pair<int, int> > (kek, {INF, INF} )));
    vector<vector<vector<pair<int, int> > > > vert(m, vector<vector<pair<int, int> > > (n, vector<pair<int, int> > (kek, {INF, INF} )));
    vector<vector<char> > s(n, vector<char> (m));
    vector<int> dist(kek);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            scanf(" %c", &s[i][j]);
    for (int i = 0; i < n; i++){
        for (int k = 0; k < 26; k++)
            dist[k] = INF;
        for (int j = 0; j < m; j++){
            for (int k = 0; k < 26; k++){
                if (dist[k] != INF){
                    gor[i][j][k].first = j - dist[k];
                    gor[i][j][k].second = dist[k];
                }
            }
            dist[int(s[i][j] - 'a')] = j;
        }
        for (int k = 0; k < 26; k++)
            dist[k] = INF;
        for (int j = m - 1; j >= 0; j--){
            for (int k = 0; k < 26; k++){
                if (dist[k] != INF){
                    if (dist[k] - j < gor[i][j][k].first){
                        gor[i][j][k].first = dist[k] - j;
                        gor[i][j][k].second = dist[k];
                    }
                }
            }
            dist[int(s[i][j] - 'a')] = j;
        }
    }
    for (int i = 0; i < m; i++){
        for (int k = 0; k < 26; k++)
            dist[k] = INF;
        for (int j = 0; j < n; j++){
            for (int k = 0; k < 26; k++){
                if (dist[k] != INF){
                    vert[i][j][k].first = j - dist[k];
                    vert[i][j][k].second = dist[k];
                }
            }
            dist[int(s[j][i] - 'a')] = j;
        }
        for (int k = 0; k < 26; k++)
            dist[k] = INF;
        for (int j = n - 1; j >= 0; j--){
            for (int k = 0; k < 26; k++){
                if (dist[k] != INF){
                    if (dist[k] - j < vert[i][j][k].first){
                        vert[i][j][k].first = dist[k] - j;
                        vert[i][j][k].second = dist[k];
                    }
                }
            }
            dist[int(s[j][i] - 'a')] = j;
        }
    }
    int q;
    scanf("%d", &q);
    for (int k = 0; k < q; k++){
        int x, y;
        scanf("%d%d", &x, &y);
        x--;
        y--;
        int v1 = -1;
        int v2 = -1;
        int u1 = -1;
        int u2 = -1;
        for (int i = 0; i < 26; i++){
            if (v1 == -1 || gor[x][y][i].first <= gor[x][y][v1].first){
                v2 = v1;
                v1 = i;
                continue;
            }
            if (v2 == -1 || gor[x][y][i].first < gor[x][y][v2].first){
                v2 = i;
                continue;
            }
        }
        for (int i = 0; i < 26; i++){
            if (u1 == -1 || vert[y][x][i].first <= vert[y][x][u1].first){
                u2 = u1;
                u1 = i;
                continue;
            }
            if (u2 == -1 || vert[y][x][i].first < vert[y][x][u2].first){
                u2 = i;
                continue;
            }
        }
        if (v1 != u1 && gor[x][y][v1].first != INF && vert[y][x][u1].first != INF){
            cout << x + 1 << " " << gor[x][y][v1].second + 1 << " " << vert[y][x][u1].second + 1 << " " << y + 1 << "\n";
            continue;
        }
        else{
            if (gor[x][y][v1].first + vert[y][x][u2].first < gor[x][y][v2].first + vert[y][x][u1].first){
                if (gor[x][y][v1].first != INF && vert[y][x][u2].first != INF){
                    cout << x + 1 << " " << gor[x][y][v1].second + 1 << " " << vert[y][x][u2].second + 1 << " " << y + 1 << "\n";
                    continue;
                }
            }
            else
                if (gor[x][y][v2].first != INF && vert[y][x][u1].first != INF){
                    cout << x + 1 << " " << gor[x][y][v2].second + 1 << " " << vert[y][x][u1].second + 1 << " " << y + 1 << "\n";
                    continue;
                }
        }
        cout << -1 << endl;
    }
    return 0;
}
