//#include <iostream>
#include <cmath>
#include <cstdio>
#include <vector>
#include <set>

using namespace std;

struct pas
{
    int a, b;
};

bool operator<(const pas &a, const pas &b)
{
    if (a.a == b.a)
        return a.b < b.b;
    return a.a < b.a;
}

struct pl
{
    int b, place;
    bool used;
};

bool operator<(const pl &a, const pl &b)
{
    return a.b < b.b;
}

int n, m, k, fre = 0;
vector <int> t;
set <pas> s;
set <pl> p;
set <int> open;

int main()
{
    scanf("%d%d%d", &n, &m, &k);
    fre = m - 1;
    t.resize(m, 0);
    for (int i = 0; i < k; i++)
    {
        pas pasang;
        scanf("%d%d", &pasang.a, &pasang.b);
        s.insert(pasang);
    }
    for (int i = 0; i < m; i++)
        open.insert(i);

    while (!s.empty() || !p.empty())
    {
        while (!p.empty() && (s.empty() || (*p.begin()).b <= (*s.begin()).a))
        {
            pl place = (*p.begin());
            if (place.used)
            {
                open.insert(place.place);
            }
            else
                fre++;
            p.erase(p.begin());
        }

        if (!s.empty())
        {
            pas pasanger = (*s.begin());
            if (fre > 0)
            {
                fre--;
                p.insert({pasanger.b, 0, false});
            }
            else
            {
                p.insert({pasanger.b, *open.begin(), true});
                t[*open.begin()] += pasanger.b - pasanger.a;
                open.erase(open.begin());
            }
            s.erase(s.begin());
        }
    }

    int ans = 1e9, it;
    for (int i = 0; i < m; i++)
    {
        if (t[i] < ans)
        {
            ans = t[i];
            it = i + 1;
        }
    }
    printf("%d %d", ans, it);
    return 0;
}


/*
10 2 3
1 10
3 9
7 10
*/
