#include <iostream>
#include <cmath>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int64_t MOD = 1e18;

int64_t lens(int64_t a, int64_t b) {
    if (b >= a)
        return b - a;

    return (1e18 - b) + (a - 1);
}

int main()
{
    int64_t x, m;
    cin >> x >> m;

    cout << "? " << 1 << endl;
    int64_t res;
    cin >> res;

    int64_t pos = res - 1 + x;
    while (pos > MOD)
        pos -= MOD;
    vector<int64_t> finds;
    for (int64_t i = pos - m; i <= pos + 500 - m; ++i) {
        int64_t pu = i + MOD;
        while (pu > MOD)
            pu -= MOD;
        finds.push_back(pu);
    }

    //for (int i = 0; i <= 500; i++)
     //   cout << finds[i] << " ";
    //cout << endl;
    int l = 0, r = 501;
    while (r - l > 1) {
        int mid = (l + r) / 2;

        cout << "? " << finds[mid] << endl;
        cin >> res;

        if (res <= x) {
            l = mid;
        } else {
            r = mid;
        }
    }

    cout << "! " << finds[l];

    return 0;
}


/*
10 2 5
1 1000000000
2 5
2 5
3 9
7 10
*/

/*
10 2 3
1 10
3 9
7 10
*/
