#include <iostream>
#include <cmath>
#include <cstdio>
#include <vector>
#include <set>
#include <algorithm>
#include <cassert>

using namespace std;

int64_t MOD = 1000000000000000000;


int main()
{
    int64_t x, m;
    cin >> x >> m;

    if (m == 0) {
        cout << "? " << 1 << endl;
        int64_t res;
        cin >> res;

        int64_t ans = res + x - 1;
        while (ans > MOD)
            ans -= MOD;
        ans += MOD;
        while (ans > MOD)
            ans -= MOD;

        cout << "! " << ans << endl;
        return 0;
    }

    cout << "? " << 1 << endl;
    int64_t res;
    cin >> res;

    int64_t pos = res - 1 + x;
    MOD -= m;
    while (pos > MOD)
        pos -= MOD;
    vector<int64_t> finds;
    for (int64_t i = pos - 499; i <= pos; ++i) {
        int64_t pu = i + MOD;
        while (pu > MOD)
            pu -= MOD;
        finds.push_back(pu);
    }

    //for (int i = 0; i <= 500; i++)
    //    cout << finds[i] << " ";
    //cout << endl;

    int cnts = 1;

    int l = 0, r = 500;
    while (r - l > 1) {
        int mid = (l + r) / 2;

        cout << "? " << finds[mid] << endl;
        cin >> res;
        cnts++;
        if (res > x + 10000)
            l = mid;
        else if (res < x - 10000)
            r = mid;
        else if (res <= x) {
            l = mid;
        } else {
            r = mid;
        }
    }

    if (cnts > 10) {
        assert(false);
    }

    cout << "! " << finds[l] << endl;

    return 0;
}


/*
10 2 5
1 1000000000
2 5
2 5
3 9
7 10
*/

/*
10 2 3
1 10
3 9
7 10
*/
