#include <iostream>

using namespace std;
const int64_t q = 510510;

bool has_100(int64_t n) {
    int64_t res = 0, c;
    for (int64_t i = 2; i * i <= n; i++) {
        c = 1;
        while (n % i == 0) {
            n /= i;
            c++;
        }
        res *= c;
        if (res >= 100)
            return true;
    }
    if (n > 1)
        res *= 2;
    return res >= 100;
}

int main() {
    int64_t n, ans, brdr;
    cin >> n;
    brdr = n + n / 100 + 1;
    ans = ((n - 1) / q + 1) * q;
    if (ans < brdr) {
        cout << ans;
        return 0;
    }
    for (int64_t i = n; i < brdr; i++) {
        if (has_100(i)) {
            cout << i << endl;
            return 0;
        }
    }
    cout << -1;
    return 0;
}
