#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define x first
#define y second

const int maxn = 2e5 + 100;

const int inf = 2e18;

bool comp(pair<int, int> a, pair<int, int> b)
{
    if (a.x < b.x)
        return true;
    else
        return false;
}

int main()
{
    vector<ll> ans(maxn);

    int n, m, k;
    scanf("%d %d %d", &n, &m, &k);
    assert(n <= 1e9 && m >= 1 && m <= 2e5 && k >= 0 && k <= 2e5);
    assert(n > 10000);
    set<int> s, f;
    for (int i = 1; i <= m; ++i)
    {
        if (i > 1)
            s.insert(i);
        f.insert(i);
    }
    deque<pair<int, int> > q;
    for (int i = 0; i < k; ++i)
    {
        int t1, t2;
        scanf("%d %d", &t1, &t2);
        assert(t2 > t1);
        assert(t1 > 0);
        assert(t2 > 0);
        assert(t2 <= n);
        q.push_back({t1, t2});
    }
    sort(q.begin(), q.end(), comp);
    set<pair<int, pair<int, int> > > q2;
    int t = 0;
    while (!q.empty())
    {
         t = q.front().x;
         if (!q2.empty())
            t = min(t, (*q2.begin()).x);
        while (!q2.empty() && ((*q2.begin()).x == t))
         {
             pair<int, pair<int, int> > nxt = *q2.begin();
             q2.erase(nxt);

             if (nxt.y.y == 1)
             {
                 s.insert(nxt.y.x);
             }
             else if (nxt.y.y == 2)
             {
                 f.insert(nxt.y.x);
             }
         }
         while (!q.empty() && q.front().x == t)
         {
             pair<int, int> next = q.front();
             q.pop_front();
             if (!s.empty())
             {
                 q2.insert({next.y, {*s.begin(), 1}});
                 s.erase(s.begin());
             }
             else if (!f.empty())
             {
                 int place = *f.begin();
                 f.erase(place);

                 ans[place] += (ll)(next.y - next.x);

                 q2.insert({next.y, {place, 2}});
             }
         }
    }
    ll Min = inf;
    for (int i = 1; i <= m; ++i)
        Min = min(Min, ans[i]);
    for (int i = 1; i <= m; ++i)
    {
        if (ans[i] == Min)
        {
            printf("%lld %d", ans[i], i);
            return 0;
        }
    }
    return 0;
}
