#include <bits/stdc++.h>
#define fs first
#define sc second
#define mp make_pair
#define pb push_back
using namespace std;

struct happen {
    int type;
    int ind, val;

    happen(int _type, int _ind, int _val) {
        type = _type;
        ind = _ind;
        val = _val;
    }
};

bool operator <(happen a, happen b) {
    if (a.val < b.val) {return true;}
    if (a.val > b.val) {return false;}
    if (a.type < b.type) {return true;}
    if (a.type > b.type) {return false;}
    return (a.ind < b.ind);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    if (k == 0) {
        cout << 0 << ' ' << 1;
        return 0;
    }
    set <happen> st;
    int in[k], out[k];
    for (int i = 0; i < k; i++) {
        cin >> in[i] >> out[i];
        st.insert(happen(1, i, in[i]));
        st.insert(happen(0, i, out[i]));
    }
    pair <int, int> pos[k];
    set <int> sit;
    set <int> stay;
    for (int i = 1; i <= m; i++) {
        sit.insert(i);
        stay.insert(i);
    }
    sit.erase(m);
    int time = 1;
    int res = 0;
    for (int i = 0; i < 2 * k; i++) {
        auto it = st.begin();
        int new_time = (*it).val;
        if (stay.find(m) == stay.end()) {
            res +=  new_time - time;
        }
        if ((*it).type == 0) {
            if (pos[(*it).ind].fs == 1) {
                sit.insert(pos[(*it).ind].sc);
            } else {
                if (pos[(*it).ind].fs == 2) {
                    stay.insert(pos[(*it).ind].sc);
                }
            }
        } else {
            if (sit.size()) {
                pos[(*it).ind].fs = 1;
                pos[(*it).ind].sc = (*(sit.begin()));
                sit.erase(sit.begin());
            } else {
                if (stay.size()) {
                    pos[(*it).ind].fs = 2;
                    pos[(*it).ind].sc = (*(stay.begin()));
                    stay.erase(stay.begin());
                } else {
                    pos[(*it).ind].fs = -1;
                }
            }
        }
        st.erase(st.begin());
        time = new_time;
    }
    int l = 0;
    int r = m;
    while (r - l > 1) {
        int mid = (r + l) / 2;
        for (int i = 0; i < k; i++) {
            st.insert(happen(1, i, in[i]));
            st.insert(happen(0, i, out[i]));
        }
        for (int i = 1; i <= m; i++) {
            sit.insert(i);
            stay.insert(i);
        }
        sit.erase(mid);
        time = 1;
        int new_res = 0;
        for (int i = 0; i < 2 * k; i++) {
            auto it = st.begin();
            int new_time = (*it).val;
            if (stay.find(mid) == stay.end()) {
                new_res +=  new_time - time;
            }
            if ((*it).type == 0) {
                if (pos[(*it).ind].fs == 1) {
                    sit.insert(pos[(*it).ind].sc);
                } else {
                    if (pos[(*it).ind].fs == 2) {
                        stay.insert(pos[(*it).ind].sc);
                    }
                }
            } else {
                if (sit.size()) {
                    pos[(*it).ind].fs = 1;
                    pos[(*it).ind].sc = (*(sit.begin()));
                    sit.erase(sit.begin());
                } else {
                    if (stay.size()) {
                        pos[(*it).ind].fs = 2;
                        pos[(*it).ind].sc = (*(stay.begin()));
                        stay.erase(stay.begin());
                    } else {
                        pos[(*it).ind].fs = -1;
                    }
                }
            }
            st.erase(st.begin());
            time = new_time;
        }
        if (new_res == res) {
            r = mid;
        } else {
            l = mid;
        }
    }
    cout << res << ' ' << r;
    return 0;
}
