import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by orspc on 11.12.2016.
 */
public class Main {
    public void solve() throws IOException {
        int t = nextInt();
        while (t > 0) {
            t--;
            long a = nextLong(), n = nextLong();

            long count = 1;
            while (count <= a) {
                count *= 2;
            }
            long k = ((count - 1) / n);
            while (((k * n) ^ a) > a) {
                k--;
            }
            if (k == 0) {
                out.println(a);
            } else {
                while (count > k * n) {
                    count /= 2;
                }
                long min = (k * n) ^ a;
                while ((k * n) >= count) {
                    k--;
                    min = Math.min(min, (k * n) ^ a);
                }
                out.println(min);

            }
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public void run() throws IOException {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }
}
