#include <bits/stdc++.h>

using namespace std;

#define pb push_back
#define mp make_pair
#define sqr(n) ( (n) * (n) )
#define size(n) ( int( n.size() ) )

const int N = 5010, M = 1000 * 1000 + 5, mod = 1000 * 1000 * 1000 + 7;
int a[N][N], row[N], col[N], b[4][M], sz[4], h, w, ans = 0;

string s;

void print(){
    int i, j;
    for ( i = 0; i < h; i++ ){
        for ( j = 0; j < w; j++ ){
            cout << a[ row[i] ][ col[j] ] << " ";
        }
        cout << endl;
    }
}

int main(){
    //freopen("input.txt","r",stdin);
    ios_base::sync_with_stdio( false );
    int  n;

    cin >> h >> w >> n;
    cin >> s;
    int i, j;
    for ( i = 0; i < h; i++ ){
        for ( j = 0; j < w; j++ ){
            a[i][j] = i * w + j;
        }
    }
    for ( i = 0; i < h; i++ ){
        row[i] = i;
    }
    for ( j = 0; j < w; j++ ){
        col[j] = j;
    }
    int r;
    for ( i = 0; i <= 3; i++ ){
        cin >> sz[i];
        if ( i % 2 == 0 ){
            r = h;
        }
        else{
            r = w;
        }
        for ( j = 0; j < sz[i]; j++ ){
            cin >> b[i][j];
        }
        for ( j = sz[i]; j < n; j++ ){
            b[i][j] = ( 10007 * 1ll * b[i][j-2] + 10009 * 1ll * b[i][j-1] + 87277 ) % r;
        }
    }
    char ch;
    int l;
    for ( i = 0; i < n; i++ ){
        ch = s[i];
        if ( ch == 'c' ){
            l = b[1][i];
            r = b[3][i];
            swap( col[l], col[r] );
        }
        else
        if ( ch == 'r' ){
            l = b[0][i];
            r = b[2][i];
            swap( row[l], row[r] );
        }
        else{
            int cx, cy, tx, ty;
            cx = row[ b[0][i] ];
            cy = col[ b[1][i] ];
            tx = row[ b[2][i] ];
            ty = col[ b[3][i] ];
            swap( a[cx][cy], a[tx][ty] );
        }
    }
    //print();
    int pw17 = 1, pw19;
    for ( i = 0; i < h; i++ ){
        pw19 = 1;
        for ( j = 0; j < w; j++ ){
            ans = ( ans + ( ( ( a[ row[i] ][ col[j] ] * 1ll * pw17 ) % mod ) * 1ll * ( pw19 ) ) % mod ) % mod;
            pw19 = ( pw19 * 1ll * 19 ) % mod;
        }
        pw17 = ( pw17 * 1ll * 17 ) % mod;
    }
    cout << ans << endl;
    return 0;
}
