#include <bits/stdc++.h>
using namespace std;

const int k = 27, inf = 1e9;

int ans(int x, int y, int _x, int _y){
    if(abs(_x) == inf || abs(_y) == inf) cout << -1 << "\n";
    else cout << _x+1 << " " << y+1 << " " << x+1 << " " << _y+1 << "\n";
}

int val(int x, int y, int _x, int _y){
    return abs(x-_x) + abs(y-_y);
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<string> s(n);

    for(int i = 0; i < n; i++)
        cin >> s[i];

    vector< vector< vector<int> > > h(n, vector< vector<int> > (m, vector<int> (k, inf)));
    vector< vector< vector<int> > > v(n, vector< vector<int> > (m, vector<int> (k, inf)));

    for(int i = 0; i < n; i++){
        vector<int> t(k, -inf);
        for(int j = 0; j < m; j++){
            h[i][j] = t;
            t[s[i][j]-'a'] = j;
        }
    }

    for(int i = 0; i < n; i++){
        vector<int> t(k, inf);
        for(int j = m-1; j >= 0; j--){
            for(int c = 0; c < k; c++)
                if(j-h[i][j][c] > t[c]-j)
                    h[i][j][c] = t[c];
            t[s[i][j]-'a'] = j;
            //for(int c = 0; c < k; c++) cerr << i << " " << j << " " << c << " " << h[i][j][c] << endl;
        }
    }

    for(int i = 0; i < m; i++){
        vector<int> t(k, -inf);
        for(int j = 0; j < n; j++){
            v[j][i] = t;
            t[s[j][i]-'a'] = j;
        }
    }

    for(int i = 0; i < m; i++){
        vector<int> t(k, inf);
        for(int j = n-1; j >= 0; j--){
            for(int c = 0; c < k; c++)
                if(j-v[j][i][c] > t[c]-j)
                    v[j][i][c] = t[c];
            t[s[j][i]-'a'] = j;
            //for(int c = 0; c < k; c++) cerr << i << " " << j << " " << c << " " << v[j][i][c] << endl;
        }
    }

    int q;
    cin >> q;

    while(q--){
        int x, y;
        cin >> x >> y;
        x--, y--;
        int h1 = 0, h2 = 26;
        for(int i = 0; i < 26; i++)
            if(abs(h[x][y][i]-y) < abs(h[x][y][h1]-y))
                h1 = i;
        for(int i = 0; i < 26; i++)
            if(i != h1 && abs(h[x][y][i]-y) < abs(h[x][y][h2]-y))
                h2 = i;
        int v1 = 0, v2 = 26;
        for(int i = 0; i < 26; i++)
            if(abs(v[x][y][i]-x) < abs(v[x][y][v1]-x))
                v1 = i;
        for(int i = 0; i < 26; i++)
            if(i != v1 && abs(v[x][y][i]-x) < abs(v[x][y][v2]-x))
                v2 = i;
        //cerr << "debug " << h1 << " " << h2 << " " << v1 << " " << v2 << endl;
        if(h1 != v1) ans(x, y, v[x][y][v1], h[x][y][h1]);
        else if(val(x, y, v[x][y][v1], h[x][y][h2]) < val(x, y, v[x][y][v2], h[x][y][h1])) ans(x, y, v[x][y][v1], h[x][y][h2]);
        else ans(x, y, v[x][y][v2], h[x][y][h1]);
    }

    return 0;
}
