#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <climits>
#include <cinttypes>

using namespace std;

typedef long long i64;
typedef pair < int, int > pii;
typedef pair < int, pii > piii;
#define mp(x, y) make_pair(x, y)
#define tri(x, a, b, c) x(a, x(b, c))
#define quad(x, a, b, c, d) x(x(a, b), x(c, d))
#define mendl '\n';
const int INF = 1e9;

int main() {

	ios::sync_with_stdio(0);
	cin.tie(0);

	i64 x;
	cin >> x;
	bool flag = 1;
	if (x >= 4536000){
		cout << (x / 45360 + 1 ) * 45360;
	}
	else{
		for (int i = x; i <= (double)x * 1.01; i++){
			i64 n = i, cnt = 1, k = 0;
			for (int j = 2; j <= sqrt(i); j++){
				k = 0;
				while (n % j == 0){
					n /= j;
					k++;
				}
				cnt *= (k + 1);
			}
			if (n > 1){
				cnt *= 2;
			}
			if (cnt >= 100){
				cout << i;
				flag = 0;
				break;
			}
		}
		if (flag){
			cout << -1;
		}
	}
	
	return 0;
}
