import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class A {
    String fileName = "<name>";

    public class Pair implements Comparable<Pair> {
    	int x;
    	int t;
    	int i;
		public Pair(int x, int y, int i) {
			this.x = x;
			this.t = y;
			this.i = i;
		}
		@Override
		public int compareTo(Pair o) {
			if (this.x != o.x) {
				return this.x - o.x;
			}
			if (this.t != o.t) {
				return this.t - o.t;
			}
			return this.i - o.i;
		}
		@Override
		public String toString() {
			return "Pair [x=" + x + ", t=" + t + ", i=" + i + "]";
		}

		
		
    }
    
    public void solve() throws IOException {
    	int n = nextInt(), m = nextInt(), k = nextInt();
    	int[] a = new int[k];
    	int[] b = new int[k];
    	Pair[] e = new Pair[2 * k];
    	for (int i = 0; i < k; i++) {
			a[i] = nextInt();
			b[i] = nextInt();
			e[2 * i] = new Pair(a[i], 0, i);
			e[2 * i + 1] = new Pair(b[i], 1, i);
		} 
    	Arrays.sort(e);
    	TreeSet<Integer> f = new TreeSet<>();
    	for (int i = 0; i < m; i++) {
			f.add(i);
		}
    	TreeMap<Integer, Integer> d = new TreeMap<>();
    	
    	int sit = 0;
    	int[] res = new int[m];
    	for (int zzz = 0; zzz < e.length; zzz++) {
			int x = e[zzz].x;
			int t = e[zzz].t;
			int i = e[zzz].i;
			if (t == 0) {
				if (sit < m - 1) {
					sit++;
					d.put(i, -1);
				} else if (!f.isEmpty()) {
					int pos = f.first();
					d.put(i, pos);
					f.remove(pos);
				} else {
					d.put(i, -4);
				}
			} else {
				int pos = d.get(i);
				if (pos == -2) {
					
				} else if (pos == -1) {
					sit--;
				} else {
					res[pos] += (b[i] - a[i]);
					f.add(pos);
				}
			}
		}
    	
    	int min = Integer.MAX_VALUE, mini = -1;
    	for (int i = 0; i < m; i++) {
			if (res[i] < min) {
				mini = i;
				min = res[i];
			}
		}
    	
    	System.out.println(min + " " + (mini + 1));
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

//            br = new BufferedReader(new FileReader(new File("input.txt"))); 
//            out = new PrintWriter(System.out);
            
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    @Override
	public String toString() {
		return "A [fileName=" + fileName + ", br=" + br + ", in=" + in + ", out=" + out + "]";
	}

	BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new A().run();
    }

}
