#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; i++)

const int N = 200100;
const int INF = 1e9;

int n, k, m, a[N], d1[N], d2[N];

inline int get_right(int i) {
    int l = -1, r = i;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (a[i] - a[m] + 1 <= k)
            r = m;
        else
            l = m;
    }
    return r - 1;
}

inline int get_left(int i) {
    int l = i, r = m;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (a[m] - a[i] + 1 <= k)
            l = m;
        else
            r = m;
    }
    return l + 1;
}

int main()
{
    cin >> n >> k >> m;
    forn(i, m) {
        cin >> a[i];
    }
    sort(a, a + m);
    int ans = n;
    fill(d1, d1 + N, INF);
    fill(d2, d2 + N, INF);
    forn(i, m) {
        // end
        int q = get_right(i);
        if (q == -1)
            d1[i] = min(k, a[i]);
        else
            d1[i] = d1[q] + k;
    }
    for (int i = m - 1; i >= 0; i--) {
        // end
        int q = get_left(i);
        if (q == m)
            d2[i] = min(k, n - a[i] + 1);
        else
            d2[i] = d2[q] + k;
    }
    ans = min(d1[m - 1], d2[0]);
    for (int i = 0; i < n - 1; i++)
        ans = min(ans, d1[i] + d2[i + 1]);
    /*
    forn(i, m)
        cout << d1[i] << ' ';
        cout << endl;
        forn(i, m)
        cout << d2[i] << ' ';
        cout << endl;
        */

    cout << n - ans << endl;
    return 0;
}


/*



*/
