#include <bits/stdc++.h>

using namespace std;

#define rep(i,a,n) for(int (i)=(a);(i)<(n);++(i))
#define per(i,a,n) for(int (i)=(n)-1;(i)>=(a);--(i))
#define F first
#define S second
#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define all(x) (x).begin(),(x).end()
#define SZ(x) (int)(x).size()

template <typename T>
T getint(){
    T x=0,p=1;
    char ch;
    do {ch=getchar();} while(ch<=' ');
    if(ch=='-')p=-1,ch=getchar();
    while(ch>='0'&&ch<='9'){
        x=x*10+(ch-'0');
        ch=getchar();
    }
    return (p==-1?-x:x);
}

typedef long double ld;
typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vll;
typedef pair<int,int> pii;
typedef pair<ll,ll> pll;

template <typename T, typename T2> bool umin(T&x, T2 y) {if(x>y){x=y; return true;} return false;}
template <typename T, typename T2> bool umax(T&x, T2 y) {if(x<y){x=y; return true;} return false;}

mt19937 gen(chrono::system_clock::now().time_since_epoch().count());

const int maxn=(int)5e3+10;
const int inf=(int)1e9+5;
const int INF=(int)1e9+5;
const int mod=(int)1e9+7;
const ll LLINF=(ll)1e18+5;
const ll llinf=(ll)1e18+5;
const ld pi=acos(-1.0);

int n,m,q;
int a[maxn][maxn];
char s[1000500];

vector<int> ax,bx,cx,dx;

void read(vi &a,int mod){
    int k=getint<int>();
    a.resize(k);
    rep(i,0,k)a[i]=getint<int>();
    rep(i,k,q){
        a[i]=(10007LL*a[i-2]+10009*a[i-1]+87277)%mod;
    }
}

int R[maxn],C[maxn];
int pw17[maxn],pw19[maxn];

int main() {

   // freopen("input.txt","r",stdin);
   // freopen("output.txt","w",stdout);

    n=getint<int>();
    m=getint<int>();
    rep(i,0,n)rep(j,0,m){
        a[i][j]=i*m+j;
    }
    q=getint<int>();
    scanf("%s",s);

    read(ax,n);
    read(bx,m);
    read(cx,n);
    read(dx,m);

    rep(i,0,n)R[i]=i;
    rep(j,0,m)C[j]=j;

    rep(i,0,q){
        if(s[i]=='c'){
            swap(C[bx[i]],C[dx[i]]);
        }else if(s[i]=='r'){
            swap(R[ax[i]],R[cx[i]]);
        }else {
            int x1=R[ax[i]];
            int y1=C[bx[i]];
            int x2=R[cx[i]];
            int y2=C[dx[i]];
            swap(a[x1][y1],a[x2][y2]);
        }
    }

    pw17[0]=pw19[0]=1;
    rep(i,1,maxn){
        pw17[i]=(pw17[i-1]*17)%mod;
        pw19[i]=(pw19[i-1]*19)%mod;
    }
    long long res=0;
    rep(i,0,n){
        rep(j,0,m){
            int v=a[R[i]][C[j]];
            long long val=v;
            val*=pw17[i]; val%=mod;
            val*=pw19[j]; val%=mod;
            res+=val;
            if(res>=mod)res-=mod;
        }
    }
    printf("%I64d\n",res);
    return 0;
}
