#include <iostream>
#include <algorithm>
#include <vector>
#define SZ(v) (int)v.size()
using namespace std;
const int N = 305;
const long long INF = (1LL << 61);
typedef long long ll;
ll d[N][N], n, k;
ll deg[N], ki, x;
vector<int> g[N];

int main()
{
#define int long long
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	cin >> n >> k;
	for (int i = 1; i <= n; i++){
		cin >> ki;
		for (int j = 0; j < ki; j++){
			cin >> x;
			deg[x]++;
			g[x].push_back(i);
		}
	}
	for (int i = 1; i <= n; i++){
		fill(d[i] + 1, d[i] + n + 1, INF);
		d[i][i] = 0;
	}
	for (int j = 1; j <= k; j++){
		for (int fi = 0; fi < SZ(g[j]); fi++)
			for (int se = 0; se < SZ(g[j]); se++)
				d[g[j][fi]][g[j][se]] = min(d[g[j][fi]][g[j][se]], deg[j]);
	}
	for (int i = 1; i <= n; i++)
		for (int j = 1; j <= n; j++)
			for (int kk = 1; kk <= n; kk++)
				if(i != j && i != kk && j != kk)
					d[i][j] = min(d[i][j], d[i][kk] + d[kk][j] - 1);
	for (int i = 1; i <= n; i++){
		for (int j = 1; j <= n; j++)
			cout << (d[i][j] == INF ? -1 : d[i][j]) << " ";
		cout << endl;
	}
}