#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <ctime>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
    
typedef long long ll;
    
const ll INF = (ll)1e18;
    
ll div(ll n) {
	std::map<ll, ll> f;
	for (ll i = 2; i * i <= n; ++i) {
		while (n % i == 0) {
			++f[i];
			n /= i;
		}
	}
	if (n > 1) {
		++f[n];
	}
	ll res = 1;
	for (auto it: f) {
		res *= it.second + 1;
	}
	return res;
}

int main(void) {
    ll n;
	scanf("%lld\n", &n);
	ll first = n, second = n + n / 100;
	if (div(first) >= 100) {
		printf("%lld\n", first);
	} else if (div(second) >= 100) {
		printf("%lld\n", second);
	} else {
		printf("-1\n");
	}
    return 0;
}