#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, m;
vector <string> v;
vector < vector <int> > rowL[26], rowR[26];
vector < vector <int> > colL[26], colR[26];

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    v.resize(n);
    for (int i = 0; i < n; i++)
        cin >> v[i];
    for (int k = 0; k < 26; k++) {
        rowL[k].resize(n); rowR[k].resize(n);
        colL[k].resize(m); colR[k].resize(m);
        for (int i = 0; i < n; i++) {
            rowL[k][i].assign(m, -12345678);
            rowR[k][i].assign(m, -12345678);
        }
        for (int i = 0; i < m; i++) {
            colL[k][i].assign(n, -12345678);
            colR[k][i].assign(n, -12345678);
        }
    }
    for (int k = 0; k < 26; k++) {
        for (int i = 0; i < n; i++)
            for (int j = 0; j + 1 < m; j++) {
                if (v[i][j] == k + 'a')
                    rowL[k][i][j+1] = j;
                else
                    rowL[k][i][j+1] = rowL[k][i][j];
            }

        for (int i = 0; i < n; i++)
            for (int j = m - 1; j > 0; j--) {
                if (v[i][j] == k + 'a')
                    rowR[k][i][j-1] = j;
                else
                    rowR[k][i][j-1] = rowR[k][i][j];
            }

        for (int i = 0; i + 1 < n; i++)
            for (int j = 0; j < m; j++) {
                if (v[i][j] != k + 'a')
                    colL[k][j][i+1] = i;
                else
                    colL[k][j][i+1] = colL[k][j][i];
            }

        for (int i = n - 1; i > 0; i--)
            for (int j = 0; j < m; j++) {
                if (v[i][j] != k + 'a')
                    colR[k][j][i-1] = i;
                else
                    colR[k][j][i-1] = colR[k][j][i];
            }
    }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int a, b; cin >> a >> b; a--, b--;
        int ax = -1, ay = -1, ansC = 2345678;
        for (int k = 0; k < 26; k++) {
            int nx1 = rowL[k][a][b];
            int nx2 = rowR[k][a][b];
            int nx;
            if (abs(b - nx1) < abs(b - nx2))
                nx = nx1;
            else
                nx = nx2;
            int ny1 = colL[k][b][a];
            int ny2 = colR[k][b][a];
            int ny;
            if (abs(a - ny1) < abs(a - ny2))
                ny = ny1;
            else
                ny = ny2;
            int tmp = abs(nx - b) + abs(ny - a);
            if (tmp < ansC) {
                ax = nx;
                ay = ny;
                ansC = tmp;
            }
        }
        if (ax < 0 || ay < 0) {
            cout << -1;
        } else {
            cout << a+1 << " " << ax+1 << " " << ay+1 << " " << b+1;
        }
        cout << "\n";
    }
    return 0;
}
