#include <stdio.h>
#include <vector>
#include <bits/stdc++.h>
#include <algorithm>

using namespace std;

const int MAXN = 5e5 + 227 + 1;
const int inf = 2e9;
//const int INFINT = 1e9 + 227 + 1;
//const long long INF = 1e18 + 227 + 1;
const int MOD = (int)1e9 + 7;

#define all(a) (a).begin(), (a).end()
#define f first
#define ll long long
#define s second
#define pb push_back
#define mp make_pair

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do {ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch > ' ') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

int main() {
//    ios::sync_with_stdio(0);
//     freopen(".in", "r", stdin);
//    freopen(".out", "w", stdout);

    int n, m;
    scanf("%d %d", &n, &m);

    vector<vector<char> > a(n, vector<char>(m));

    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++) {
            char c = '\n';
            while (c == '\n') {
                c = getchar();
            }

            a[i][j] = c - 'a';
        }
    vector< vector<int> > up(n, vector<int>(m, inf)), dw, lf, rf;
    dw = up;
    lf = up;
    rf = up;

    for (int i = 1; i < n; i++) {
        for (int j = 0; j < m; j++)
                if (a[i - 1][j] != a[i][j])
                    up[i][j] = 1;
                else
                    up[i][j] = min(inf, up[i - 1][j] + 1);
    }

    for (int i = n - 2; i >= 0; i--) {
        for (int j = 0; j < m; j++)
                if (a[i + 1][j] != a[i][j])
                    dw[i][j] = 1;
                else
                    dw[i][j] = min(inf, dw[i + 1][j] + 1);
    }

    for (int j = 1; j < m; j++)
        for (int i = 0; i < n; i++)
                if (a[i][j - 1] != a[i][j])
                    lf[i][j] = 1;
                else
                    lf[i][j] = min(inf, lf[i][j - 1] + 1);

    for (int j = m - 2; j >= 0; j--)
        for (int i = 0; i < n; i++)
            if (a[i][j + 1] != a[i][j])
                rf[i][j] = 1;
            else
                rf[i][j] = min(inf, rf[i][j + 1] + 1);
    int q;
    scanf("%d", &q);

    while (q--) {
        int x, y;
        x = next_int<int>();
        y = next_int<int>();
        x--, y--;

        pair<int, pair<int, int> > ans;
        ans.f = inf;


    // 0
        int x1 = x, y1 = y - 1;
        if (y1 >= 0) {
            int x2 = x - 1, y2 = y;
            if (x2 >= 0 && a[x1][y1] != a[x2][y2]) {
                ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(0, abs(y - y1))));
            }
            if (x2 >= 0 && up[x2][y2] != inf) {
                x2 -= up[x2][y2];
                if (a[x1][y1] != a[x2][y2]) {
                    ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(0, abs(y - y1))));
                }
            }

            if (lf[x1][y1] != inf) {
                y1 -= lf[x1][y1];
                x2 = x - 1, y2 = y;
                if (x2 >= 0 && a[x1][y1] != a[x2][y2]) {
                    ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(0, abs(y - y1))));
                }
                if (x2 >= 0 && up[x2][y2] != inf) {
                    x2 -= up[x2][y2];
                    if (a[x1][y1] != a[x2][y2]) {
                        ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(0, abs(y - y1))));
                    }
                }
            }
        }





        // 1

        x1 = x, y1 = y - 1;
        if (y1 >= 0) {
            int x2 = x + 1, y2 = y;
            if (x2 < n && a[x1][y1] != a[x2][y2]) {
                ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(1, abs(y - y1))));
            }
            if (x2 < n && dw[x2][y2] != inf) {
                x2 += dw[x2][y2];
                if (a[x1][y1] != a[x2][y2]) {
                    ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(1, abs(y - y1))));
                }
            }

            if (lf[x1][y1] != inf) {
                y1 -= lf[x1][y1];
                x2 = x + 1, y2 = y;
                if (x2 < n && a[x1][y1] != a[x2][y2]) {
                    ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(1, abs(y - y1))));
                }
                if (x2 < n && dw[x2][y2] != inf) {
                    x2 += dw[x2][y2];
                    if (a[x1][y1] != a[x2][y2]) {
                        ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(1, abs(y - y1))));
                    }
                }
            }
        }



        // 2

        x1 = x, y1 = y + 1;
        if (y1 < m) {
            int x2 = x - 1, y2 = y;
            if (x2 >= 0 && a[x1][y1] != a[x2][y2]) {
                ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(2, abs(y - y1))));
            }
            if (x2 >= 0 && up[x2][y2] != inf) {
                x2 -= up[x2][y2];
                if (a[x1][y1] != a[x2][y2]) {
                    ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(2, abs(y - y1))));
                }
            }

            if (rf[x1][y1] != inf) {
                y1 += rf[x1][y1];
                x2 = x - 1, y2 = y;
                if (x2 >= 0 && a[x1][y1] != a[x2][y2]) {
                    ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(2, abs(y - y1))));
                }
                if (x2 >= 0 && up[x2][y2] != inf) {
                    x2 -= up[x2][y2];
                    if (a[x1][y1] != a[x2][y2]) {
                        ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(2, abs(y - y1))));
                    }
                }
            }
        }

        x1 = x, y1 = y + 1;
        if (y1 < m) {
            int x2 = x + 1, y2 = y;
            if (x2 < n && a[x1][y1] != a[x2][y2]) {
                ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(3, abs(y - y1))));
            }
            if (x2 < n && dw[x2][y2] != inf) {
                x2 += dw[x2][y2];
                if (a[x1][y1] != a[x2][y2]) {
                    ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(3, abs(y - y1))));
                }
            }

            if (rf[x1][y1] != inf) {
                y1 += rf[x1][y1];
                x2 = x + 1, y2 = y;
                if (x2 < n && a[x1][y1] != a[x2][y2]) {
                    ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(3, abs(y - y1))));
                }
                if (x2 < n && dw[x2][y2] != inf) {
                    x2 += dw[x2][y2];
                    if (a[x1][y1] != a[x2][y2]) {
                        ans = min(ans, mp(abs(x - x1) + abs(x - x2) + abs(y - y1) + abs(y - y2), mp(3, abs(y - y1))));
                    }
                }
            }
        }


        if (ans.first == inf) {
            puts("-1");
            continue;
        }

        int type = ans.s.f;
        int alpha = ans.s.s;
        int beta = ans.f - alpha;

        if (type == 0) {
            int r1 = x - beta;
            int c2 = y - alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 1) {
            int r1 = x + beta;
            int c2 = y - alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 2) {
            int r1 = x - beta;
            int c2 = y + alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
        if (type == 3) {
            int r1 = x + beta;
            int c2 = y + alpha;

            printf("%d %d %d %d\n", r1 + 1, y + 1, x + 1, c2 + 1);
        }
    }
    return 0;
}
