#include <stdio.h>
#include <vector>
#include <bits/stdc++.h>
#include <algorithm>

using namespace std;

const int MAXN =  1e5 + 227 + 1;
const int inf = 2e9;
//const int INFINT = 1e9 + 227 + 1;
//const long long INF = 1e18 + 227 + 1;
const int MOD = (int)1e9 + 7;

#define all(a) (a).begin(), (a).end()
#define f first
#define ll long long
#define s second
#define pb push_back
#define mp make_pair

template <typename T>
T next_int() {
    T ans = 0, t = 1;
    char ch;
    do {ch = getchar(); } while(ch <= ' ') ;
    if(ch == '-') {
        t = -1;
        ch = getchar();
    }
    while(ch > ' ') {
        ans = ans * 10 + (ch - '0');
        ch = getchar();
    }
    return ans * t;
}

struct node {
    node *to[26];
    vector<int> ids[26];
    bool type;

    node(bool type) {
        for(int i = 0; i < 26; i++) {
            to[i] = 0;
            ids[i].clear();
        }
        this -> type = type;
    }
};

node *root = new node(0);
string q[MAXN];
int pos[MAXN];

pair<node*, char> add(const string& str) {
    node *cur = root;
    pair<node*, char> ans = {0, 0};
    for(int i = 0; i < str.size(); i++) {
        if(!(cur -> to[str[i] - 'a'])) {
            if(!ans.first)
                ans = {cur, str[i]};
            node *temp = new node(0);

            cur -> to[str[i] - 'a'] = temp;
            cur = temp;
        } else {
            cur = cur -> to[str[i] - 'a'];
        }
    }
    cur -> type = 1;

    return ans;
}

bool push(node *cur, int id) {
    while(pos[id] < q[id].size()) {
        if(cur -> to[q[id][pos[id]] - 'a'] == 0) {
            break;
        }

        cur = cur -> to[q[id][pos[id]] - 'a'];
        if(cur -> type == 1)
            cur = root;

        pos[id]++;
    }
    if(pos[id] == q[id].size())
        return 1;
    cur -> ids[q[id][pos[id]] - 'a'].push_back(id);
//    exit(0);
    return 0;
}

int main() {
    ios::sync_with_stdio(0);
//     freopen(".in", "r", stdin);
//    freopen(".out", "w", stdout);

    int n, lst = 0;
    int cnt = 0;
    cin >> n;

    vector<int> ans;

    for(int i = 0; i < n; i++) {
        string type;
        cin >> type;

        string str;
        cin >> str;

        lst %= str.size();
        string a = str.substr(0, lst);
        string b = str.substr(lst, string::npos);

        str = b + a;
//        cout << str << "\n";

        ans.clear();

        if(type == "+") {
            pair<node*, char> p = add(str);

            vector<int> temp = p.first -> ids[p.second - 'a'];

            p.first -> ids[p.second - 'a'].clear();

            for(int i : temp) {
                if(push(p.first, i))
                    ans.push_back(i);
            }

        } else {
            q[cnt] = str;
            pos[cnt] = 0;

            if(push(root, cnt))
                ans.push_back(cnt);
            cnt++;
        }

        cout << ans.size() << " ";
        for(int i = 0; i < ans.size(); i++) {
            cout << ans[i] + 1 << " ";
        }
        cout << "\n";
        lst = ans.size();
    }
    return 0;
}
