#include <stdio.h>
#include <iostream>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

struct ev { 
	int pos;
	int bal;
	int id;
	ev() { }
	ev(int pos, int bal, int id) : pos(pos), bal(bal), id(id) { }
	bool operator<(const ev& b) const { 
		if (pos != b.pos)
			return pos < b.pos;
		if (bal != b.bal)
			return bal < b.bal;
		return id < b.id;
	}
};

int main() {
	//freopen("input.in", "r", stdin);
	int n, m, k;
	cin >> n >> m >> k;

	vector<ev> evs;
	for (int i = 0; i < k; i++) {
		int u, v;
		scanf("%d%d", &u, &v);

		evs.push_back(ev(u, 1, i));
		evs.push_back(ev(v, -1, i));
	}
	sort(evs.begin(), evs.end());

	int free = m - 1;
	vector<int> poses(k, 0);
	set<int> free_stay;
	vector<int> beg(m, -1);
	vector<int> cnt(m, 0);

	for (int i = 0; i < m; i++)
		free_stay.insert(i);

	for (int i = 0; i < evs.size(); i++) {
		int now = evs[i].pos;

		if (evs[i].bal == -1) {
			if (poses[evs[i].id] == -1)
				free++;
			else if (poses[evs[i].id] == -2)
				continue;
			else {
				int pos = poses[evs[i].id];
				cnt[pos] += now - beg[pos];
				free_stay.insert(poses[evs[i].id]);
			}
		}
		else {
			if (free > 0) {
				poses[evs[i].id] = -1;
				free--;
			}
			else {
				if (free_stay.size() == 0) {
					poses[evs[i].id] = -2;
					continue;
				}
				int val = *free_stay.begin();
				free_stay.erase(free_stay.begin());
				poses[evs[i].id] = val;
				beg[val] = now;
			}
		}
	}

	int mn = 1e9 + 1;
	int mnid = -1;
	for (int i = 0; i < m; i++) {
		if (cnt[i] < mn) {
			mn = cnt[i];
			mnid = i;
		}
	}

	cout << mn << " " << mnid + 1 << "\n";
}

