#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>

using namespace std;

#define int long long

struct B_I_T
{
	vector<int> f;
	B_I_T(int n) : f(n) {}
	int add(int x, int v)
	{
		for (int i = x; i < f.size(); i = (i | (i + 1)))
			f[i] += v;
		return 1;
	}
	int sum(int x)
	{
		int ret = 0;
		for (int i = x; i >= 0; i = (i & (i + 1)) - 1)
			ret += f[i];
		return ret;
	}
	int push()
	{
		int L = 0, R = f.size();
		while (R - L > 1)
		{
			int M = (R + L) / 2;
			if (sum(M) < M + 1)
				R = M;
			else
				L = M;
		}
		if (L == 0 && f[0] == 0)
			return L * add(L, 1);
		if (R == f.size())
			return -2;
		else
			return R * add(R, 1);
	}
};

long main() {
	ios::sync_with_stdio(0);
	//ifstream cin("TEST.txt");
	int m, n, k;
	cin >> m >> n >> k;
	B_I_T T(n);
	int S = n - 1;
	vector<pair<int, int> > evs;
	vector<int> s(k), f(k);
	for (int i = 0; i < k; i++)
	{
		cin >> s[i] >> f[i];
		evs.push_back({ s[i], i + 1 });
		evs.push_back({ f[i], -(i + 1) });
	}
	sort(evs.begin(), evs.end());
	vector<int> t(n, 0);
	vector<int> a(k);
	for (auto e : evs)
	{
		if (e.second > 0)
		{
			int idx = e.second - 1;
			if (S > 0)
			{
				a[idx] = -1;
				S--;
				continue;
			}
			a[idx] = T.push();
		}
		else
		{
			int idx = - e.second - 1;
			if (a[idx] == -2)
				continue;
			if (a[idx] == -1)
			{
				S++;
				continue;
			}
			t[a[idx]] += f[idx] - s[idx];
			T.add(a[idx], -1);
		}
	}
	int mi = 0;
	for (int i = 1; i < n; i++)
		if (t[i] < t[mi])
			mi = i;
	cout << t[mi] << " " << mi + 1;
	return 0;
}