#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define pb push_back
#define mp make_pair

const int N = 300005;

vector<int> in[N];
vector<int> out[N];
int whereX[N];
int whereY[N];
vector<int> values;
pair<int,int> vv[N];
bool bad[N];
int n;

int calcBad() {
    int i = 0, ret = 0;
    while (i < (int)values.size()) {
        if (!bad[i]) {
            i++;
            continue;
        }
        int r = i;
        while (r + 1 < (int)values.size() && bad[r + 1]) r++;
        int whereBad = r + 1 < (int)values.size() ? values[r+1] : n;
        ret += whereBad - values[i];
        i = r + 1;
    }
    return ret;
}

int main() {
    int m, k;
    scanf("%d%d%d", &n, &m, &k);
    set<int> f0, f1;
    for (int i = 1; i <= m; i++) {
        if (i != m) f0.insert(i);
        f1.insert(i);
    }
    for (int i = 1; i <= k; i++) {
        int x, y;
        scanf("%d%d", &x, &y);
        values.push_back(x);
        values.push_back(y);
        vv[i] = make_pair(x, y);
    }
    sort(values.begin(), values.end());
    values.resize(unique(values.begin(),values.end())-values.begin());
    for (int i = 1; i <= k; i++) {
        int u;
        u = lower_bound(values.begin(),values.end(),vv[i].first)-values.begin();
        in[u].push_back(i);
        u = lower_bound(values.begin(),values.end(),vv[i].second)-values.begin();
        out[u].push_back(i);

    }
    int ans = 0;
    bool intervalStarted = false;
    int l = 0, r = 0;
    for (int i = 0; i < (int)values.size(); i++) {
        for (auto passenger : out[i]) {
            //cout << "- " << whereX[passenger] << " " << whereY[passenger] << endl;
            if (whereX[passenger] == 0) {
                f0.insert(whereY[passenger]);
            } else {
                f1.insert(whereY[passenger]);
            }
        }

        for (auto passenger : in[i]) {
            if (!f0.empty()) {
                auto it = f0.begin();
                whereX[passenger] = 0;
                whereY[passenger] = *it;
                f0.erase(f0.begin());
                //cout << "+ " << 0 << " " << *it << endl;
            } else if (!f1.empty()) {
                auto it = f1.begin();
                whereX[passenger] = 1;
                whereY[passenger] = *it;
                f1.erase(f1.begin());

                //cout << "+ " << 1 << " " << *it << endl;
            }
        }

        if (f1.find(m) == f1.end()) {
            bad[i] = true;
        }
    }
    printf("%d %d\n", calcBad(), m);
    return 0;
}
