#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <iterator>
#include <string>

using namespace std;
#define ten18 1000000000000000000 

long long ask(long long n){
	cout << "? " << n << endl;
	long long a;
	cin >> a;
	return a;
}

long long minn(long long num, long long min, long long m){
	if (num == -1){
		return -1;
	}
	else
	{
		long long a = (num - min) % (ten18 - m);
		if (a <= 0) {
			a += ten18 - m;
		}
		return a;
	}
}




struct passenger{
	long long from, to;
};

bool compare(passenger &p1,passenger &p2){
	
	if (p1.from < p2.from){
		return true;
	}
	if (p1.from == p2.from){
		return p1.to < p2.to;
	}
	
	return false;
}
/*
int main(){
	long long n, m, k;
	cin >> n >> k >> m;
	vector <long long> d(m,0);
	for (int i = 0; i < m; i++){
		cin >> d[i];
	}
	sort(d.begin(), d.end());
	vector < vector <long long> > group(0, vector <long long>(2));
	long long h = 0;
	for (int i = 1; i < m; i++){
		if (d[i] - d[i - 1] >= k - 1){
			vector <long long> trash(2);
			trash[0] = h;
			trash[1] = i - 1;
			group.push_back(trash);
			h = i;
		}
	}
	for (int )
	system("pause");
	return 0;
}
*/

string alph = "01";

string toBin(long long Num){
	string res = "";
	while (Num > 0){
		long long ch = Num / 2;
		res = res + alph[Num % 2];
		Num = ch;
	}
	reverse(res.begin(), res.end());
	return res;

}

void calculateDels(long long A,vector<long long> &vec){

	for (int i = 1; i <= sqrt(A); i++){
		if (A%i == 0){
			vec.push_back(i);
		}
		if (i*i != A){
			vec.push_back(A / i);
		}
	}

}

string fromXor(string a,string b){
	long long maxSize = max(a.size(), b.size());
	
	if (a.size() != maxSize){
		//cout << a.size() - maxSize << endl;
		string s="";
		for (int i = 0; i < maxSize - a.size(); i++){
			//cout<<(i)<<endl;
			s = s + '0';
		}
		a = s + a; 
	}
	if (b.size() != maxSize){
		string s = "";
		for (int i = 0; i < maxSize - b.size(); i++){
			s = s + '0';
		}
		b = s + b;
	}
	string res="";
	for (int i = 0; i < maxSize; i++){
		if (a[i] == '0' && b[i] == '1'){
			res = res + '1';
		}
		if (a[i] == '1' && b[i] == '0'){
			res = res + '1';
		}
		if (a[i] == '0' && b[i] == '0'){
			res = res + '0';
		}
		if (a[i] == '1' && b[i] == '1'){
			res = res + '0';
		}
	}

	return res;

}
long long fromBin(string s){
	long long ten = 1;
	long long res = 0;
	for (int i = s.size() - 1; i >= 0; i--){
		if (s[i] == '1'){
			res += ten;
		}
		ten *= 2;
	}
	return res;
}

int main(){
	int K;
	cin >> K;
	
	for (int i = 0; i < K; i++){
		long long minB = -1;
		long long A, N;
		cin >> A >> N;
		string Abin = toBin(A);
		string Nbin = toBin(N);

		for (int i = 0; i < 10; i++){
			long long res = N *i;
			string Resbin = toBin(res);
			string bBin = fromXor(Abin, Resbin);
			long long b = fromBin(bBin);
			if (minB == -1){
				minB = b;
			}
			else{
				minB = min(minB, b);
			}
		}
		cout << minB << endl;

	}
	return 0;
}

/*
int main(){
	long long N, M, K;
	cin >> N >> M >> K;
	
	vector<passenger> allPassengers (K);
	for (long long i = 0; i < K; i++){
		cin >> allPassengers[i].from >> allPassengers[i].to;
	}
	sort(allPassengers.begin(), allPassengers.end(), compare);
	

	system("pause");
	return 0;
}
*/
/*
int main(){
	long long n;
	long long m;
	cin >> n;
	cin >> m;
	long long result = ask(1);
	long long maxx = 0;
	if (result > n){
		maxx = (n - result + 1 + m) % (ten18 - m + 1);
		if (maxx <= 0){
			maxx += ten18 - m;
		}
	}
	else {
		maxx = (n - result + 1) % (ten18 - m + 1);
		if (maxx <= 0){
			maxx += ten18 - m;
		}
	}
	//cout << maxx;
	//long long from = (result - m) % (ten18-m);
	//if (from == 0){
	//	from = ten18 - m;
	//}
	long long back = m / 2;
	long long t = back / 2;
	long long h1 = -1;
	long long h2 = -1;
	//cout <<result << back << m << minn(result, back,m);
	long long to = result;
	long long middle;
	for (int i = 0; i < 9; i++){
		//long long middle = (from + to) / 2;
		middle = minn(maxx, back, m);
		long long b = ask(middle);
		if (b == n){
			break;
		}
		else {
			if (((b > n) && (b - n <= m)) || ((b < n) && (n - b > m))){
				back += t;
				h2 = middle;
			}
			else{
				back -= t;
				h1 = middle;
			}
			t = (t + 1) / 2;
			if (t == 0){
				t = 1;
			}
			if ((
				h1 >= 0) && (h2 >= 0))
				if ((h1 - h2 == 1) || (h1 - h2 == -1)){
					middle = -1;
					break;
				}
		}
		//cout << back << endl;
	}
	cout << "! " << middle << endl;
	//cout << max << endl;
	//system("pause");
	//system("pause");
	return 0;
}
*/
/*
int main1(){
	long long n;
	long long m;
	cin >> n;
	cin >> m;
	long long result = ask(1);
	long long max = (n - result + 1 + ten18 - m) % (ten18 - m);
	if (max == 0){
		max = ten18 - m;
	}

	//long long from = (result - m) % (ten18-m);
	//if (from == 0){
	//	from = ten18 - m;
	//}
	long long back = m / 2;
	long long t = back / 2;
	//cout <<result << back << m << minn(result, back,m);
	long long to = result;
	for (int i = 0; i < 9; i++){
		//long long middle = (from + to) / 2;
		long long middle = minn(max, back, m);
		long long b = ask(middle);
		if (b == n){
			break;
		}
		if (b > n)
			back += t;
		else
			back -= t;
		t = (t + 1) / 2;
		if (t == 0){
			t = 1;
		}
		//cout << back << endl;
	}
	cout << "! " << minn(max, back, m);
	//cout << max << endl;
	system("pause");
	return 0;
}*/

