#include <stdio.h>
#include <cctype>
#include <inttypes.h>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

/*<--------------------------------------------------------------------------->*/

const int MAX_M = 2e5 + 7;

pair<int, int> pas[MAX_M];
int pas_pl[MAX_M];
int score[MAX_M];

pair<int, int> events[MAX_M*2];

void solve()
{
    int n, m, k;
    scanf("%d%d%d", &n, &m, &k);

    for (int i = 0; i < k; ++i)
    {
        scanf("%d%d", &pas[i].first, &pas[i].second);
        events[2*i] = {pas[i].first, i};
        events[2*i + 1] = {pas[i].second, -i - 1};
    }

    sort(events, events + k*2);

    set<int> free_stand;
    for (int i = 0; i < m; ++i)
        free_stand.insert(i);
    int free_sit = m-1;
    for (int i = 0; i < k*2; ++i)
    {
        if (events[i].second < 0)
        {
            events[i].second = -events[i].second - 1;
            if (pas_pl[events[i].second] == -2)
                continue;
            if (pas_pl[events[i].second] == -1)
                free_sit++;
            else
                free_stand.insert(pas_pl[events[i].second]);
        }
        else
        {
            if (free_sit)
                pas_pl[events[i].second] = -1,
                free_sit--;
            else if (free_stand.size())
                pas_pl[events[i].second] = *free_stand.begin(),
                free_stand.erase(free_stand.begin()),
                score[pas_pl[events[i].second]] += pas[events[i].second].second - pas[events[i].second].first;
            else
                pas_pl[events[i].second] = -2;
        }
    }
    int mnp = 0;
    for (int i = 1; i < m; ++i)
        if (score[i] < score[mnp])
            mnp = i;
    printf("%d %d\n", score[mnp], mnp+1);
}

/*<--------------------------------------------------------------------------->*/

//#define LOCAL

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
