#include <stdio.h>
#include <cctype>
#include <inttypes.h>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define pb push_back
#define ft first
#define sd second
#define forn(i, n) for (int (i) = 0; (i) < (n); ++(i))
#define all(x) begin((x)), end((x))
#define rall(x) (x).rbegin(), (x).rend()

/*<--------------------------------------------------------------------------->*/

const int MAX_M = 2e5 + 7;

int d[MAX_M];
int ldp[MAX_M];
int rdp[MAX_M];

void solve()
{
    int n, k, m;
    scanf("%d%d%d", &n, &k, &m);
    for (int i = 0; i < m; ++i)
        scanf("%d", d+i), d[i]--;

    sort(d, d+m);

    {
        int i, j;
        for (i = 0; i < m && d[i] - d[0] < k; ++i)
            ldp[i] = max(0, d[i] - k + 1);
        for (j = 0; i < m; ++i)
        {
            while (d[i] - d[j+1] >= k) ++j;
            ldp[i] = d[i] - d[j] - k + ldp[j];
        }
    }
    {
        int i, j;
        for (i = m-1; i >= 0 && d[m-1] - d[i] < k; --i)
            rdp[i] = max(0, n - d[i] - k);
        for (j = m-1; i >= 0; --i)
        {
            while (d[j-1] - d[i] >= k) --j;
            rdp[i] = d[j] - d[i] - k + rdp[j];
        }
    }

/*
    for (int i = 0; i < m; ++i)
        printf("%d ", ldp[i]);
    printf("\n");
    for (int i = 0; i < m; ++i)
        printf("%d ", rdp[i]);
    printf("\n");
*/

    int ans = max(ldp[0] + d[0], rdp[m-1] + n-1 - d[m-1]);
    for (int i = 1; i < m; ++i)
        ans = max(ans, ldp[i-1] + rdp[i] + d[i] - d[i-1] - 1);

    printf("%d\n", ans);

}

/*<--------------------------------------------------------------------------->*/

//#define LOCAL

int main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL

    ios_base::sync_with_stdio(0);
    cin.tie(0);

    solve();

    return 0;
}
