#include <bits/stdc++.h>

#define ll long long

using namespace std;

struct event {

    int s, t, p;
};

struct pelement {

    int s, a;
};

event make_event (int s, int t, int p) {

    event e;

    e.s = s;
    e.t = t;
    e.p = p;

    return e;
}

pelement make_pelement (int s, int a) {

    pelement e;

    e.s = s;
    e.a = a;

    return e;
}

bool event_comp (event a, event b) {

    return (a.s == b.s ? a.t > b.t : a.s < b.s);
}

int main () {

    ifstream cin("input.txt");

    int n, m, k;
    cin >> n >> m >> k;

    if (m == 1) {

        vector <event> e;

        for (int i = 0; i < k; i++) {

            int a, b;
            cin >> a >> b;

            e.push_back(make_event(a, 0, i));
            e.push_back(make_event(b, 1, i));
        }

        sort(e.begin(), e.end(), event_comp);

        set <int> es;

        for (int i = 1; i < m * 2; i++) {

            es.insert(i);
        }

        vector <pelement> p(k, make_pelement(-1, 0));
        vector <int> st(m, 0);

        for (int i = 0; i < k * 2; i++) {

            if (e[i].t) {

                if (p[e[i].p].s >= m) {

                    st[p[e[i].p].s - m] += e[i].s - p[e[i].p].a;

                    //cout << e[i].s - p[e[i].p].a << ' ';
                }

                es.insert(p[e[i].p].s);

            } else {

                if (es.size()) {

                    int cs = *es.begin();
                    es.erase(cs);

                    p[e[i].p] = make_pelement(cs, e[i].s);
                }
            }
        }

        vector < pair <int, int> > _st(m);

        for (int i = 0; i < m; i++) {

            _st[i] = make_pair(st[i], i);
        }

        cout << _st[0].first << ' ' << 1;

    } else {

        vector <event> e;

    for (int i = 0; i < k; i++) {

        int a, b;
        cin >> a >> b;

        e.push_back(make_event(a, 0, i));
        e.push_back(make_event(b, 1, i));
    }

    sort(e.begin(), e.end(), event_comp);

    set <int> es;

    for (int i = 0; i < m * 2; i++) {

        es.insert(i);
    }

    vector <pelement> p(k, make_pelement(0, 0));
    vector <int> st(m, 0);

    for (int i = 0; i < k * 2; i++) {

        if (e[i].t) {

            if (p[e[i].p].s >= m) {

                st[p[e[i].p].s - m] += e[i].s - p[e[i].p].a;
            }

            es.insert(p[e[i].p].s);

        } else {

            if (es.size()) {

                int cs = *es.begin();
                es.erase(cs);

                p[e[i].p] = make_pelement(cs, e[i].s);
            }
        }
    }

    vector < pair <int, int> > _st(m);

    for (int i = 0; i < m; i++) {

        _st[i] = make_pair(st[i], i);
    }

    if (_st[0].first == m - 1) {

        cout << _st[1].first << ' ' << _st[1].second + 2;

    } else {

        cout << _st[0].first << ' ' << _st[0].second + 2;
    }
    }
}
