#include <stdio.h>
#include <bits/stdc++.h>

#define X first
#define Y second
#define all(v) v.begin(), v.end()
#define SZ(v) (int)(v.size())
#define pb push_back

using namespace std;

typedef pair<int, int> ii;
typedef long long ll;

const int INF = 100000000;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
  //  freopen("input.txt", "r", stdin);
    int n, m;
    cin>>n>>m;
    char a[n][m];
    for(int i=0; i<n; i++)
        for(int j=0; j<m; j++)
            cin>>a[i][j];
    int u[n][m][26];
    int d[n][m][26];
    int l[n][m][26];
    int r[n][m][26];
    for(int c=0; c<26; c++) {
        for(int i=0; i<n; i++)
            for(int j=0; j<m; j++) {
                l[i][j][c]=u[i][j][c]=INF;
                if(j&&a[i][j-1]==c+'a')l[i][j][c]=1;
                else if(j&&l[i][j-1][c]<INF)l[i][j][c]=l[i][j-1][c]+1;
                if(i&&a[i-1][j]==c+'a')u[i][j][c]=1;
                else if(i&&u[i-1][j][c]<INF)u[i][j][c]=u[i-1][j][c]+1;
            }
        for(int i=n-1; i>=0; i--)
            for(int j=m-1; j>=0; j--) {
                r[i][j][c]=d[i][j][c]=INF;
                if(j<m-1&&a[i][j+1]==c+'a')r[i][j][c]=1;
                else if(j<m-1&&r[i][j+1][c]<INF)r[i][j][c]=r[i][j+1][c]+1;
                if(i<n-1&&a[i+1][j]==c+'a')d[i][j][c]=1;
                else if(i<n-1&&d[i+1][j][c]<INF)d[i][j][c]=d[i+1][j][c]+1;
            }
    }
    int q; cin>>q;
    while(q--) {
        int I,J;
        cin>>I>>J;
        --I; --J;
        int dist=INF;
        int p1,q1=J,p2=I,q2;
        for(int c1=0; c1<26; c1++)
            if(min(u[I][J][c1],d[I][J][c1])<INF)
                for(char c2=0; c2<26; c2++)
                    if(min(l[I][J][c2],r[I][J][c2])<INF&&c1!=c2) {
                        if(u[I][J][c1]+l[I][J][c2]<dist) {
                            dist=u[I][J][c1]+l[I][J][c2];
                            p1=I-u[I][J][c1];
                            q2=J-l[I][J][c2];
                        }
                        if(u[I][J][c1]+r[I][J][c2]<dist) {
                            dist=u[I][J][c1]+r[I][J][c2];
                            p1=I-u[I][J][c1];
                            q2=J+r[I][J][c2];
                        }
                        if(d[I][J][c1]+l[I][J][c2]<dist) {
                            dist=d[I][J][c1]+l[I][J][c2];
                            p1=I+d[I][J][c1];
                            q2=J-l[I][J][c2];
                        }
                        if(d[I][J][c1]+r[I][J][c2]<dist) {
                            dist=d[I][J][c1]+r[I][J][c2];
                            p1=I+d[I][J][c1];
                            q2=J+r[I][J][c2];
                        }
                    }
        if(dist<INF)cout<<p1+1<<' '<<q1+1<<' '<<p2+1<<' '<<q2+1<<"\n";
        else cout<<-1<<"\n";
    }
    return 0;
}
