#include <iostream>
#include <cstdio>
#include <queue>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <stack>
#include <set>
#include <map>
#include <cmath>

#define FAST_READ ios_base::sync_with_stdio(false);
#define in freopen("1.txt", "r", stdin);
#define out freopen("output.txt", "w", stdout);
#define MAXN 200010
#define INF 1000000000000000
#define MOD 1000000007
#define pi 3.14159265358973238462643383
#define EPS 0.0000000000001
#define pb push_back

using namespace std;

typedef unsigned long long ull;
typedef int long long ll;
typedef long double ld;
typedef string str;
typedef pair < ll, ll > pr;

vector < ll > pow2;

inline ll f(ll a, ll b)
{
    ll k = 0, ans = 0;

    while(a || b)
    {
        if ((a & 1) != (b & 1))
            {
                ans += pow2[k];
            }
        k++;
        a /= 2;
        b /= 2;
    }

    return ans;
}

int main()
{
    FAST_READ

    ll n, a, t, f1, f2;

    pow2.resize(64, 1);

    for (int i = 1; i < 64; i++)
        pow2[i] = pow2[i - 1] * 2;

    cin >> n;

    for(int i = 0; i < n; i++)
    {
        cin >> a >> t;

        if (a % t == 0)
        {
            cout << 0 << endl;
            continue;
        }

        f1 = (a / t) * t;
        f2 = (a / t + 1) * t;

        cout << min(min(f(f1, a), f(f2, a)),min(a ^ t, a)) << endl;
    }

    return 0;
}
