#include <bits/stdc++.h>

using namespace std;

#define ll long long

bool isp[(int)1e7 + 1];
vector <ll> m;
ll mod = 1e9 + 7;
ll f[(int)1e7 + 5];
ll rf[(int)1e7 + 5];

ll binpow(ll a, ll b) {
    if (rf[a]) {
        return rf[a];
    }
    if (!b) {
        return 1;
    }
    if (b & 1)
        return rf[a] = binpow(a, b - 1) * a % mod;
    ll  res = binpow(a, b / 2) % mod;
    return rf[a] = res * res % mod;
}

int main()
{
    for (int i = 2; i * i < 1e7; i++) {
        if (!isp[i]) {
            m.push_back(i);

            for (int j = i * i; j < 1e7; j += i) {
                isp[j] = true;
            }
        }
    }
    f[0] = 1;
    for (int i = 1; i <= 1e7; i++) {
        f[i] = f[i - 1] * i % mod;
    }

    ll x;
    cin >> x;
    ll r = x + x / 100;
    while (r >= x) {
        ll cnt = 0;
        ll n = r;
        for (auto i : m) {
            while (n % i == 0) {
                n /= i;
                cnt++;
            }
        }
        ll res = 0;
        for (int i = 1; i <= cnt && res < 100; i++) {
            res += f[cnt] * binpow(f[i], mod - 2) % mod * binpow(f[cnt - i], mod - 2) % mod;
        }
        if (res >= 100) {
            cout << r;
            return 0;
        }
        r--;
    }
    {
        cout << -1;
    }
    return 0;
}
