#ifdef _DEBUG
# include <iostream>
# include <vector>
# include <string>
#else
#include <bits/stdc++.h>
#endif

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = (int)1e9 + 7;
const int SIZE = 500000;

int main()
{
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
#endif

  int n, m;
  scanf("%d %d\n", &n, &m);

  char str[SIZE];
  vector<string> a(n);
  for (int i = 0; i < n; i++)
  {
	gets(str);
	a[i] = string(str);
  }

  vector<vector<int>> b[26][2];

  for (int i = 0; i < 26; i++)
	for (int j = 0; j < 2; j++)
	{
	b[i][j].resize(n);

	for (int k = 0; k < n; k++)
	  b[i][j][k].resize(m);
	}

  vector<int> u(n, 0), v(m, 0);

  int q;
  scanf("%d", &q);

  for (int _i = 0; _i < q; _i++)
  {
	int x, y;

	scanf("%d %d", &x, &y);

	x--; y--;

	if (u[x] == 0)
	{
	  for (int k = 0; k < 26; k++)
	  {
		int i = x;

		int last = -1;

		for (int j = 0; j < m; j++)
		{
		  b[k][0][i][j] = last;

		  if (a[i][j] == 'a' + k)
			last = j;
		}

		for (int j = m - 1; j >= 0; j--)
		{
		  if ((b[k][0][i][j] == -1 || j - b[k][0][i][j] > last - j) && last != j)
			b[k][0][i][j] = last;

		  if (a[i][j] == 'a' + k)
			last = j;
		}
	  }
	}

	if (v[y] == 0)
	{
	  for (int k = 0; k < 26; k++)
	  {
		int j = y;

		int last = -1;

		for (int i = 0; i < n; i++)
		{
		  b[k][1][i][j] = last;

		  if (a[i][j] == 'a' + k)
			last = i;
		}

		for (int i = n - 1; i >= 0; i--)
		{
		  if ((b[k][1][i][j] == -1 || j - b[k][1][i][j] > last - j) && last != i)
			b[k][1][i][j] = last;

		  if (a[i][j] == 'a' + k)
			last = i;
		}
	  }
	}

	int min = INF;
	pair<int, int> res;
	for (int i = 0; i < 26; i++)
	  for (int j = 0; j < 26; j++)
		if (i != j)
		{
	  if (abs(y - b[i][0][x][y]) + abs(x - b[j][1][x][y]) < min && b[i][0][x][y] != -1 && b[j][1][x][y] != -1)
	  {
		min = abs(y - b[i][0][x][y]) + abs(x - b[j][1][x][y]);
		res = make_pair(b[i][0][x][y], b[j][1][x][y]);
	  }
		}

	if (min == INF)
	  printf("-1\n");
	else
	  printf("%d %d %d %d\n", x + 1, res.first + 1, res.second + 1, y + 1);
  }
}