#include<bits/stdc++.h>
#define pb push_back
#define x first
#define y second

using namespace std;



struct node {
    bool term;
    int go[26];
    vector <int> dnk;
    node() {
        term = false;
        for (int j = 26; j--;) {
            go[j] = -1;
        }
    }
};

struct bor {
    vector <pair <string, int>> dnk;
    vector <node> tree;
    int cnt;
    vector <int> res;
    bor() {
        cnt = 0;
        tree.push_back(node());
    }
    string rev(string s) {
        string s1;
        int cnt1 = cnt;
        cnt1 %= s.size();
        for (int i = cnt1; i < s.size(); i++) {
            s1 += s[i];
        }
        for (int i = 0; i < cnt1; i++) {
            s1 += s[i];
        }
        return s1;
    }
    void try_dnk(int i, int j) {
        while (dnk[j].y < dnk[j].x.size()) {
            if (tree[i].term) {
                i = 0;
            }
            if (tree[i].go[dnk[j].x[dnk[j].y]] == -1) {
                break;
            }
            i = tree[i].go[dnk[j].x[dnk[j].y]];
            ++dnk[j].y;
        }
        if (dnk[j].y == dnk[j].x.size() && tree[i].term) {
            res.pb(j);
        } else {
            tree[i].dnk.pb(j);
        }
    }
    void add_dnk(string s) {
        dnk.pb({rev(s), 0});
        try_dnk(0, (int)dnk.size() - 1);
    }
    void push(int i) {
        vector <int> res;
        res = tree[i].dnk;
        tree[i].dnk.clear();
        for (int j: res) {
            if (dnk[j].y < dnk[j].x.size()) {
                if (tree[i].go[dnk[j].x[dnk[j].y]] == -1) {
                    int q = tree.size();
                    tree[i].go[dnk[j].x[dnk[j].y]] = q;
                    tree.pb(node());
                }
                int k = tree[i].go[dnk[j].x[dnk[j].y]];
                if (tree[k].term) {
                    k = 0;
                }
                //cout << k << '+' << j + 1 << endl;
                tree[k].dnk.pb(j);
                //cout << j + 1 << "!" << k << "!" << dnk[j].y << "!" << dnk[j].x.size() << endl;
                ++dnk[j].y;
            }
        }
    }
    void add_gen(string s) {
        s = rev(s);
        int i = 0;
        for (int j = 0; j < s.size(); ++j) {
            push(i);
            if (tree[i].go[s[j]] == -1) {
                int q = tree.size();
                tree[i].go[s[j]] = q;
                tree.pb(node());
            }
            i = tree[i].go[s[j]];
        }
        tree[i].term = true;
        vector <int> res;
        res = tree[i].dnk;
        tree[i].dnk.clear();
        for (int j: res) {
            try_dnk(i, j);
        }
    }
    void print_ans() {
        cnt = res.size();
        cout << res.size() << ' ';
        for (int i: res) cout << i + 1 << ' ';
        cout << '\n';
        res.clear();
    }
};

int n;
char c;
string s;
bor box;


int main() {
    ios::sync_with_stdio(false);
    cin >> n;
    for (int t = n; t--;) {
        cin >> c >> s;
        for (int j = 0; j < s.size(); ++j) {
            s[j] -= 'a';
        }
        if (c == '?') {
            box.add_dnk(s);
        } else {
            box.add_gen(s);
        }
        box.print_ans();
    }
}
/*
5
? abcabd
+ abc
? abcabc
? dabdab
+ abd
*/
