#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int MAXN = 5000;

int a[MAXN][MAXN];

const int MAXQ = 1000000;
int A[MAXQ], B[MAXQ], C[MAXQ], D[MAXQ];

int main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);

	int h, w, n;
	scanf("%d%d%d", &h, &w, &n);
	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			a[i][j] = i * w + j;
		}
	}

	char buf[1000005];
	scanf(" %s", buf);

	 
	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; i++) {
		scanf("%d", &A[i]);
	}
	for (int i = k; i < n; i++) {
		A[i] = (10007 * A[i - 2] + 10009 * A[i - 1] + 87277) % h;
	}
	 
	scanf("%d", &k);
	for (int i = 0; i < k; i++) {
		scanf("%d", &B[i]);
	}
	for (int i = k; i < n; i++) {
		B[i] = (10007 * B[i - 2] + 10009 * B[i - 1] + 87277) % w;
	}
	 
	scanf("%d", &k);
	for (int i = 0; i < k; i++) {
		scanf("%d", &C[i]);
	}
	for (int i = k; i < n; i++) {
		C[i] = (10007 * C[i - 2] + 10009 * C[i - 1] + 87277) % h;
	}
	 
	scanf("%d", &k);
	for (int i = 0; i < k; i++) {
		scanf("%d", &D[i]);
	}
	for (int i = k; i < n; i++) {
		D[i] = (10007 * D[i - 2] + 10009 * D[i - 1] + 87277) % w;
	}

	vector<int> p(h), q(w);
	for (int i = 0; i < h; i++) {
		p[i] = i;
	}
	for (int i = 0; i < w; i++) {
		q[i] = i;
	}

	for (int i = 0; i < n; i++) {
		if (buf[i] == 'c') {
			swap(q[B[i]], q[D[i]]);
		} else if (buf[i] == 'r') {
			swap(p[A[i]], p[C[i]]);
		} else {
			swap(a[p[A[i]]][q[B[i]]], a[p[C[i]]][q[D[i]]]);
		}
	}

	const int MOD = 1000000007;
	long long ans = 0;
	vector<long long> p17(h + 1);
	p17[0] = 1;
	for (int i = 0; i < h; i++) {
		p17[i + 1] = p17[i] * 17 % MOD;
	}
	vector<long long> p19(w + 1);
	p19[0] = 1;
	for (int i = 0; i < w; i++) {
		p19[i + 1] = p19[i] * 19 % MOD;
	}

	for (int i = 0; i < h; i++) {
		for (int j = 0; j < w; j++) {
			//cout << a[p[i]][q[j]] << " ";
			ans += a[p[i]][q[j]] * p17[i] % MOD * p19[j] % MOD;
		}
		//cout << endl;
	}

	cout << ans % MOD << endl;

	return 0;
}