#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
#include <set>

using namespace std;

struct ev
{
	int i, ty, ti;
	ev(){}
	ev(int ty, int ti, int i) : ty(ty), ti(ti), i(i){}
	bool operator <(const ev &a) const {
		if (ti < a.ti)
			return 1;
		if (ti > a.ti)
			return 0;
		if (ty < a.ty)
			return 1;
		if (ty > a.ty)
			return 0;
		return i < a.i;
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	int n, m, k;
	cin >> n >> m >> k;
	vector < ev > a;
	a.push_back({ 0, n, 0 });
	a.push_back({ 1, 1, 0 });
	vector < pair < int, int > > b(k + 1), whr(k + 1);
	b[0] = { 1, n };
	set < int > fr, st;
	for (int i = 1; i <= m; i++) {
		fr.insert(i);
		st.insert(i);
	}
	for (int i = 0; i < k; i++) {
		int x, y;
		cin >> x >> y;
		b[i + 1] = { x, y };
		a.push_back({ 1, x, i + 1 });
		a.push_back({ 0, y, i + 1 });
	}
	vector < int > ans(m + 1, 0);
	sort(a.begin(), a.end());
	for (ev cur : a) {
		if (cur.ty) {
			if (fr.size()) {
				int x = *fr.begin();
				fr.erase(x);
				whr[cur.i] = { 0, x };
			}
			else {
				if (st.size()) {
					int x = *st.begin();
					st.erase(x);
					whr[cur.i] = { 1, x };
					ans[x] += b[cur.i].second - cur.ti;
				}
				else {
					whr[cur.i] = { -1, -1 };
				}
			}
		}
		else {
			if (whr[cur.i].first == -1)
				continue;
			if (whr[cur.i].first)
				st.insert(whr[cur.i].second);
			else
				fr.insert(whr[cur.i].second);
		}
	}
	int mn = 1e9 + 10, _ans;
	for (int i = m; i >= 1; i--) {
		if (ans[i] <= mn) {
			mn = ans[i];
			_ans = i;
		}
	}
	cout << mn << ' ' << _ans;
	return 0;
}