#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:25600000")
#include <iostream>
#include <fstream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <cstring>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

#define TASK ""

int solve();
const long long LINF = (long long)1e18;

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	return solve();
};

long long r = 0;
map<long long, long long> w;
int op = 0;

long long ask(long long v) {
	v = (v + r - 1) % r + 1;
	if (w[v] != 0){
		return w[v];
	}
	op++;
	if (op == 11) {
		assert(0);
	}
	printf("? %lld\n", v);
	
	long long ans;
	fflush(stdout);
	scanf("%lld", &ans);
	w[v] = ans;
	return ans;
}
long long t;
bool cmp(long long a, long long b) {
	long long d1 = min(abs(a - t), r - abs(a - t) - 1);
	long long d2 = min(abs(b - t), r - abs(b - t) - 1);
	return d1 > d2;
}

int solve() {
	long long x, m;
	cin >> x >> m;
	r = (long long)1e18 - m;
	t = ask(1);
//	x = ((x - t + 1) + r) % r;
	long long px = ((x - t) + r) % r + 1;
	long long pos2 = (px - m) - 1;
	long long pos1 = px + 1;
	while (pos1 - pos2 > 1) {
		long long tm = (pos1 + pos2) / 2;
		long long p = ask(tm);
		//p = (p - t + 1 + r) % r;
		if (cmp(p, x)) {
			pos1 = tm;
		}
		else {
			pos2 = tm;
		}
	}
	/*if (pos1 == px + 1) {
		if (ask(pos2) != x) {
			cout << "! " << -1 << endl;
			return 0;
		}
		else {
			cout << "! " << (pos2 + r - 1) % r + 1 << endl;
			return 0;
		}
	}
	if (pos2 == (px - m) - 1) {
		if (ask(pos1) != x) {
			cout << "! " << -1 << endl;
			return 0;
		}
		else {
			cout << "! " << (pos1 + r - 1) % r + 1 << endl;
			return 0;
		}
	}*/
	if (ask(pos1) == x) {
		cout << "! " << (pos1 + r - 1) % r + 1 << endl;
		return 0;
	}
	if (ask(pos2) == x) {
		cout << "! " << (pos2 + r - 1) % r + 1 << endl;
		return 0;
	}
	cout << "! " << -1 << endl;
	return 0;
}
