#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::abs;
using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
};

int main() {
    int a, b, c;
    cin >> a >> b >> c;
    if (a + b == c or a + c == b or b + c == a) {
        cout << 0 << "\n";
        return 0;
    }
    if (b >= a && b >= c) {
        int x = (b + a - c) / 2;
        cout << 2 << std::endl;
        cout << b - x << ' ' << x << '\n';
        return 0;
    }


    if (a >= b && a >= c) {
        cout << 1 << std::endl;
        int x = (b + a - c) / 2;
        cout << a - x << ' ' << x << '\n';
        return 0;
    }


    if (c >= b && a <= c) {
        cout << 3 << std::endl;
        int x = (c + a - b) / 2;
        cout << c - x << ' ' << x << '\n';
        return 0;
    }
    return 0;
}
