#include <bits/stdc++.h>

using std::cerr;
using std::cin;
using std::cout;

using std::abs;
using std::min;
using std::max;
using std::swap;

using std::map;
using std::pair;
using std::set;
using std::string;
using std::vector;

using ll = long long;
using uint = unsigned int;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#define sqr(x) ((x)*(x))
#ifdef LOCAL
#define dbg(as...) { \
    vector<string> _v;\
    std::stringstream _ss(#as);\
    string _cur, _loc;\
    while (getline(_ss, _cur, ',')) {\
        while(count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
            getline(_ss, _loc, ',');\
            _cur += "," + _loc;\
        }\
        _v.pb(_cur);\
    }\
    err(_v.begin(),as);\
}
#else
#define dbg(as...)
#endif // LOCAL

template<typename T>
void err(vector<string>::iterator it, T a) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, a);
}
template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
    cerr << (it->substr((*it)[0] == ' ')) << " = " << a << '\n';
    err(++it, as...);
}

struct init{
    init() {
        cin.tie(0);
        std::iostream::sync_with_stdio(0);
        cerr << std::fixed << std::setprecision(10);
        cout << std::fixed << std::setprecision(10);
        srand(300);
    }
    ~init() {
        cerr << "Time : " << 1.0 * clock() / CLOCKS_PER_SEC << " s.\n";
    }
};

int main() {
    #define int ll
    int n, k, m;
    cin >> n >> k >> m;
    vector<int> d(m);
    for (int & i : d)
        cin >> i;
    sort(d.begin(), d.end());
    vector<int> dps(m);
    for (int i = m - 1; i >= 0; --i) {
        auto next = lower_bound(d.begin(), d.end(), d[i] + k);
        if (next == d.end())
            dps[i] = max(0LL, n - d[i] - k + 1);
        else
            dps[i] = max(0LL, dps[next - d.begin()] + d[next - d.begin()] - d[i] - k);
    }
    vector<int> dpp(m);
    reverse(d.begin(), d.end());
    for (int i = m - 1; i >= 0; --i) {
        auto next = lower_bound(d.begin(), d.end(), d[i] - k, std::greater<int>());
        if (next == d.end())
            dpp[i] = max(0LL, d[i] - k);
        else
            dpp[i] = max(dpp[next - d.begin()] + d[i] - d[next - d.begin()] - k, 0LL);
    }
    reverse(dpp.begin(), dpp.end());

    reverse(d.begin(), d.end());

    int ans = 0;
    for (int i = 0; i < m; ++i) {
        int pot = (i == 0 ? 0 : dpp[i - 1]) + dps[i] + max(0LL, d[i] - (i == 0 ? 0 : d[i - 1]) - 1);
//            cout << i << ' ' << dpp[i] << ' ' << dps[i] << ' ' << pot << '\n';
        if (ans < pot)
            ans = pot;
    }
    {
        int pot = dpp[m - 1] + max(0LL, n - d[m - 1] - 1);
        if (ans < pot)
            ans = pot;
    }

    cout << ans << '\n';


    return 0;
}
