#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <iomanip>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <deque>
#include <queue>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 1e5;
const ll LINF = 1e18 + 1e15;
const ld EPS = 1e-7;
const ll MOD = 1e9 + 7;


ll cnt;
ll cntq;
ll xx;
map<ll, ll> mp;

ll norm(ll a) {
	while (a > cnt) a -= cnt;
	while (a <= 0) a += cnt;
	return a;
}

ll ans(ll a) {
	cout << "! " << norm(a) << endl;
	exit(0);
}

ll check(ll a) {
	if (mp.count(norm(a))) return mp[norm(a)];
	ll ca = norm(a);
	cntq++;
	assert(cntq <= 10);
	cout << "? " << norm(a) << endl;
	cin >> a;
	mp[ca] = a;
	if (a == xx) ans(ca);
	return a;
}

int run() {
	ll x, m;
	cin >> x >> m;
	xx = x;
	cnt = (ll)1e+18 - m;
	ll d = check(1);
	if (d == x) ans(1);
	d--;
	ll l = x - m - d - 1;
	ll r = x - d + 2;
	while (l + 1 < r) {
		ll mid = (l + r) >> 1;
		ll val = check(mid);
		if (val == x) ans(x);
		if (abs(x - val) > 30000) {
			if (x > val) val += cnt + 10000;
			else val -= cnt + 10000;
		}
		cerr << val << endl;
		if (val > x) r = mid;
		else l = mid;
	}

	cout << "! -1" << endl;
	return 0;
}

signed main() {
	/*ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);*/
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#endif
	run();
#ifdef _DEBUG
	cerr << "\nok";
	while (1);
#endif
	return 0;
}