#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <queue>
#include <set>
#include <algorithm>
#include <map>
#include <bitset>
#include <string>
#include <string>

using namespace std;

typedef long long ll;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)1e7 + 7;

int T[dd], iT;

bool prime(int x) {
	for (int i = 2; i * i <= x; i++)
		if (x % i == 0)
			return false;
	return true;
}

ll Q;
ll n;

void gen(int i, ll cnt, ll num) {

	if (iT == i) {
		if (num >= n && cnt >= 100) {
			cout << num;
			exit(0);
		}
		return;
	}

	ll p = 1;

	for (int it = 0; ; it++) {
		gen(i + 1, cnt * p, num);

		p++;
		num *= T[i];

		if (num > Q)
			return;
	}
}

int solve() {

	for (int i = 2; i <= 50; i++) {
		if (prime(i))
			T[iT++] = i;
	}

	cin >> n;
	Q = (ll)(n * 1.01);

	gen(0, 1, 1);
	
	cout << -1;
	return 0;
}