#include <bits/stdc++.h>

using namespace std;

const int INF = (int)1e9 + 7;
const int N = (int)1e6;

vector< vector< vector< pair<int, int> > > > res;
int last[26];
string s[N];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    //freopen("input.txt", "r", stdin);

    /*cout << "500 1000\n";
    for (int i = 0; i < 500; i++) {
        for (int j = 0; j < 1000; j++)
            cout << char('a' + j % 26);
        cout << '\n';
    }
    cout << "1000000\n";
    for (int i = 0; i < (int)1e6; i++)
        cout << "1 1\n";*/
    int n, m, q;
    cin >> n >> m;

    res.assign(n,
               vector< vector< pair<int, int> > >(m,
                           vector< pair<int, int> >(26, pair<int, int>(INF, INF))
                            )
                           );

    for (int i = 0; i < n; i++)
        cin >> s[i];

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 26; j++)
            last[j] = -1;
        for (int j = 0; j < m; j++) {
            for (int k = 0; k < 26; k++)
                if (last[k] != -1)
                    res[i][j][k].first = (abs(res[i][j][k].first - j) > abs(j - last[k]) ? last[k] : res[i][j][k].first);
            last[s[i][j] - 'a'] = j;
        }

        for (int j = 0; j < 26; j++)
            last[j] = -1;
        for (int j = m - 1; j >= 0; j--) {
            for (int k = 0; k < 26; k++)
                if (last[k] != -1)
                    res[i][j][k].first = (abs(res[i][j][k].first - j) > abs(j - last[k]) ? last[k] : res[i][j][k].first);

            last[s[i][j] - 'a'] = j;
        }
    }

    for (int j = 0; j < m; j++) {
        for (int i = 0; i < 26; i++)
            last[i] = -1;
        for (int i = 0; i < n; i++) {
            for (int k = 0; k < 26; k++)
                if (last[k] != -1)
                    res[i][j][k].second = (abs(res[i][j][k].second - i) > abs(i - last[k]) ? last[k] : res[i][j][k].second);

            last[s[i][j] - 'a'] = i;
        }

        for (int i = 0; i < 26; i++)
            last[i] = -1;
        for (int i = n - 1; i >= 0; i--) {
            for (int k = 0; k < 26; k++)
                if (last[k] != -1)
                    res[i][j][k].second = (abs(res[i][j][k].second - i) > abs(i - last[k]) ? last[k] : res[i][j][k].second);

            last[s[i][j] - 'a'] = i;
        }
    }

    cin >> q;
    int x, y;
    for (int ppp = 0; ppp < q; ppp++) {
        cin >> x >> y, x--, y--;
        int ansJ = res[x][y][0].first, ansI = res[x][y][1].second;

        vector< pair<int, int> > pr(26), sf(26);

        for (int i = 0; i < 26; ++i)
            pr[i] = (i == 0 ? make_pair(abs(y - res[x][y][i].first), res[x][y][i].first)
                     : min(pr[i - 1], make_pair(abs(y - res[x][y][i].first), res[x][y][i].first)));

        for (int i = 25; i >= 0; --i)
            sf[i] = (i == 25 ? make_pair(abs(y - res[x][y][i].first), res[x][y][i].first)
                     : min(sf[i + 1], make_pair(abs(y - res[x][y][i].first), res[x][y][i].first)));

        for (int i = 0; i < 26; ++i)
        {
            pair<int, int> zhopa = make_pair(INF, 228);
            if (i > 0) zhopa = min(zhopa, pr[i - 1]);
            if (i < 25) zhopa = min(zhopa, sf[i + 1]);

            if (abs(ansJ - y) + abs(ansI - x) > abs(zhopa.first) + abs(res[x][y][i].second - x))
                ansJ = zhopa.second, ansI = res[x][y][i].second;
        }

        /*for (int k1 = 0; k1 < 26; k1++)
            for(int k2 = 0; k2 < 26; k2++)
                if (k1 != k2)
                    if (abs(ansJ - y) + abs(ansI - x) > abs(res[x][y][k1].first - y) + abs(res[x][y][k2].second - x))
                        ansJ = res[x][y][k1].first, ansI = res[x][y][k2].second;*/

        if (ansJ == INF || ansI == INF)
            cout << -1 << endl;
        else
            cout << x + 1 << ' ' << ansJ + 1 << ' ' << ansI + 1 << ' ' << y + 1 << endl;
    }

    return 0;
}

