#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
using namespace std;

//#define int long long
#define endl "\n"

int n, k, m;


int dst(pair <int, int> A, pair <int, int> B) {
//    if (A.second < B.first)
    return max(0, min(A.second, B.second) - max(A.first, B.first) + 1);
}

int sol_1(vector <int> & days) {
    vector <pair <int, int> > ans;
    ans.push_back(make_pair(days[0] - k + 1, days[0]));
    for (int i = 1; i < days.size(); i++) {
        if (days[i] > ans.back().second) {
            ans.push_back(make_pair(days[i], days[i] + k - 1));
        }
    }
    int answer = 0;
    for (auto elem : ans) {
        answer += dst(elem, make_pair(1, n));
    }
    return n - answer;
}

int sol_2(vector <int> & days) {
    vector <pair <int, int> > ans;
    ans.push_back(make_pair(days[0], days[0] + k - 1));
    for (int i = 1; i < days.size(); i++) {
        if (days[i] > ans.back().second) {
            ans.push_back(make_pair(days[i], days[i] + k - 1));
        }
    }
    int answer = 0;
    for (auto elem : ans) {
        answer += dst(elem, make_pair(1, n));
    }
    return n - answer;
}

signed main() {
    cin >> n >> k >> m;
    vector <int> day(m);
    for (int i = 0; i < m; i++) {
        cin >> day[i];
    }
    sort(day.begin(), day.end());
    int answer = sol_1(day);
    answer = max(answer, sol_2(day));

    reverse(day.begin(), day.end());
    for (int i = 0; i < m; i++) {
        day[i] = n + 1 - day[i];
    }
    answer = max(answer, sol_1(day));
    answer = max(answer, sol_2(day));


    cout << answer << endl;
    return 0;
}
