#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;
typedef long long ll;
int n, m;
int dx[] = {1, 0, -1, 0};
int dy[] = {0, -1, 0, 1};
bool check(int a, int b){
    return (a >= 0 && a < n && b >= 0 && b < m);
}
int min(int a, int b){
    if(a < b) return a;
    return b;
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
	cin >> n >> m;
	int a[n][m];
	for (int i = 0; i < n; i++){
        for (int j = 0; j < m; j++){
            char c;
            cin >> c;
            a[i][j] = c - 'a';
        }
	}
	int left[n][m], right[n][m], up[n][m], down[n][m];
	for(int i = 0; i < n; i++)
        for(int j = 0; j < m; j++)
            left[i][j] = right[i][j] = up[i][j] = down[i][j] = 1e6;
	for(int i = 0; i < n; i++){
        for(int j = 1; j < m; j++)
            if(a[i][j] == a[i][j - 1])
                left[i][j] = left[i][j - 1] + 1;
            else
                left[i][j] = 1;
	}
	for(int i = 0; i < n; i++){
        for(int j = m - 2; j >= 0; j--)
            if(a[i][j] == a[i][j + 1])
                right[i][j] = right[i][j + 1] + 1;
            else
                right[i][j] = 1;
	}
	for(int i = 1; i < n; i++){
        for(int j = 0; j < m; j++)
            if(a[i][j] == a[i - 1][j])
                up[i][j] = up[i - 1][j] + 1;
            else
                up[i][j] = 1;
	}
	for(int i = n - 2; i >= 0; i--){
        for(int j = 0; j < m; j++)
            if(a[i][j] == a[i + 1][j])
                down[i][j] = down[i + 1][j] + 1;
            else
                down[i][j] = 1;
	}
	int q;
	cin >> q;
	for(int e = 0; e < q; e++){
        int x, y;
        cin >> x >> y;
        x--, y--;
        int ansx1, ansy1, ansx2, ansy2;
        int mindist = 1e6;
        if (check(x - 1, y) && check(x, y - 1)) {
            if (a[x-1][y] != a[x][y-1]){
                cout << x << ' ' << y + 1 << ' ' << x + 1 << ' ' << y << '\n';
                continue;
            }
        }
        if (check(x - 1, y) && check(x, y + 1)) {
            if (a[x-1][y] != a[x][y+1]){
                cout << x << ' ' << y + 1 << ' ' << x + 1 << ' ' << y + 2 << '\n';
                continue;
            }
        }
        if (check(x + 1, y) && check(x, y - 1)) {
            if (a[x+1][y] != a[x][y-1]){
                cout << x+2 << ' ' << y + 1 << ' ' << x + 1 << ' ' << y << '\n';
                continue;
            }
        }
        if (check(x + 1, y) && check(x, y + 1)) {
            if (a[x + 1][y] != a[x][y + 1]){
                cout << x + 2 << ' ' << y + 1 << ' ' << x + 1 << ' ' << y + 2 << '\n';
                continue;
            }
        }
        //111
        if(check(x + 1, y) && check(x, y - 1) && check(x, y - 1 - left[x][y - 1]))
            if(a[x + 1][y] != a[x][y - 1 - left[x][y - 1]])
                if(2 + left[x][y - 1] < mindist){
                    ansx1 = x + 1, ansy1 = y, ansx2 = x, ansy2 = y - 1 - left[x][y - 1];
                    mindist = 2 + left[x][y - 1];
                }
        //222
        if(check(x - 1, y) && check(x, y - 1) && check(x, y - 1 - left[x][y - 1]))
            if(a[x - 1][y] != a[x][y - 1 - left[x][y - 1]])
                if(2 + left[x][y - 1] < mindist){
                    ansx1 = x - 1, ansy1 = y, ansx2 = x, ansy2 = y - 1 - left[x][y - 1];
                    mindist = 2 + left[x][y - 1];
                }

        //333
        if(check(x + 1, y) && check(x, y + 1) && check(x, y + 1 + right[x][y + 1]))
            if(a[x + 1][y] != a[x][y + 1 + right[x][y + 1]])
                if(2 + right[x][y + 1] < mindist){
                    ansx1 = x + 1, ansy1 = y, ansx2 = x, ansy2 = y + 1 + right[x][y + 1];
                    mindist = 2 + right[x][y + 1];
                }
        //444
        if(check(x - 1, y) && check(x, y + 1) && check(x, y + 1 + right[x][y + 1]))
            if(a[x - 1][y] != a[x][y + 1 + right[x][y + 1]])
                if(2 + right[x][y + 1] < mindist){
                    ansx1 = x - 1, ansy1 = y, ansx2 = x, ansy2 = y + 1 + right[x][y + 1];
                    mindist = 2 + right[x][y + 1];
                }

        //555
        if(check(x, y + 1) && check(x - 1, y) && check(x - 1 - up[x - 1][y], y))
            if(a[x - 1 - up[x - 1][y]][y] != a[x][y + 1])
                if(2 + up[x - 1][y] < mindist){
                    ansx1 = x - 1 - up[x-1][y], ansy1 = y, ansx2 = x, ansy2 = y + 1;
                    mindist = 2 + up[x-1][y];
                }

        //666
        if(check(x, y - 1) && check(x - 1, y) && check(x - 1 - up[x - 1][y], y))
            if(a[x - 1 - up[x - 1][y]][y] != a[x][y - 1])
                if(2 + up[x - 1][y] < mindist){
                    ansx1 = x - 1 - up[x-1][y], ansy1 = y, ansx2 = x, ansy2 = y - 1;
                    mindist = 2 + up[x-1][y];
                }

       //777
        if(check(x, y + 1) && check(x + 1, y) && check(x + 1 + down[x + 1][y], y))
            if(a[x + 1 + down[x + 1][y]][y] != a[x][y + 1])
                if(2 + down[x + 1][y] < mindist){
                    ansx1 = x + 1 + down[x+1][y], ansy1 = y, ansx2 = x, ansy2 = y + 1;
                    mindist = 2 + down[x+1][y];
                }

        //888
        if(check(x, y - 1) && check(x + 1, y) && check(x + 1 + down[x + 1][y], y))
            if(a[x + 1 + down[x + 1][y]][y] != a[x][y - 1])
                if(2 + down[x + 1][y] < mindist){
                    ansx1 = x + 1 + down[x+1][y], ansy1 = y, ansx2 = x, ansy2 = y - 1;
                    mindist = 2 + down[x+1][y];
                }
        if(mindist < 1e6){
            cout << ansx1 + 1 << ' ' << ansy1 + 1 << ' ' << ansx2 + 1 << ' ' << ansy2 + 1 << '\n';
        }else
        cout << "-1\n";
	}
}
