#include <iostream>
#include <stdio.h>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <set>
#include <map>
#include <climits>
#include <cinttypes>

using namespace std;

typedef long long i64;
typedef pair < int, int > pii;
typedef pair < int, pii > piii;
#define mp(x, y) make_pair(x, y)
#define tri(x, a, b, c) x(a, x(b, c))
#define quad(x, a, b, c, d) x(x(a, b), x(c, d))
#define mendl '\n'
const int INF = 1e9;
#define X first
#define Y second

int main() {

#ifdef _DEBUG
	freopen("Text.txt", "r", stdin);
#endif

	ios::sync_with_stdio(0);
	cin.tie(0);

	int n, m, k;
	cin >> n >> m >> k;

	vector < piii > events;
	int f, t;
	vector < int > in(k);
	for (int i = 0; i < k; i++) {
		cin >> f >> t;
		in[i] = f;
		events.push_back(mp(f, mp(1, i)));
		events.push_back(mp(t, mp(0, i)));
	}

	sort(events.begin(), events.end());
	vector < int > cnt(m, 0);
	vector < pii > info(k, mp(-1, -1));

	int cnt_sit = 0;
	set < int > stands;
	for (int i = 0; i < m; i++) {
		stands.insert(i);
	}

	int pass;
	for (int i = 0; i < events.size(); i++) {
		pass = events[i].Y.Y;
		if (events[i].Y.X == 1) {
			if (cnt_sit < m - 1) {
				cnt_sit++;
				info[pass].X = 0;
			}
			else {
				if (stands.size()) {
					info[pass] = mp(1, *stands.begin());
					stands.erase(stands.begin());
				}
				else {
					info[pass].X = 2;
				}
			}
		}
		else {
			if (info[pass].X == 0) {
				cnt_sit--;
			}
			else {
				if (info[pass].X == 1) {
					stands.insert(info[pass].Y);
					cnt[info[pass].Y] += events[i].X - in[pass];
				}
			}
		}
	}

	int ans = 0;
	for (int i = 1; i < m; i++) {
		if (cnt[i] < cnt[ans])
			ans = i;
	}

	cout << cnt[ans] << " " << ans + 1;

	return 0;
}
