import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Created by orspc on 11.12.2016.
 */
public class TaskI {

    public void solve() throws IOException {
        long x = nextLong();
        if (x < 45360) {
            if (101 * x >= 4536000) {
                out.println(45360);
            } else {
                out.println(-1);
            }
            return;
        }

        if (x > 4536000) {
            out.println((x + 45360 - 1) / 45360 * 45360);
            return;
        }

        for (long i = x; 100 * i <= 101 * x; i++) {
            long ii = i;
            long ans = 1;
            long j = 2;
            while (ii > 1 && j * j <= ii) {
                long cnt = 1;
                while (ii % j == 0) {
                    ii /= j;
                    cnt++;
                }
                j++;
                ans *= cnt;
            }
            if (ii > 1) {
                ans *= 2;
            }

            if (ans >= 100) {
                out.println(i);
                return;
            }
        }
        out.println(-1);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new TaskI().run();
    }

}
