#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <string>
#include <unordered_map>
#include <unordered_set>

using namespace std;

const long long INF = 1e18, M = 1e9 + 9, P = 257;

unordered_map <int, int> q(2e3);
unordered_set <long long> hes;

long long p[2000500];
vector < vector <long long> > str;
string s;

bool tac(int nom, int l, int r) {
	return hes.find(((str[nom][r] - str[nom][l - 1] * p[r - l + 1]) % M + M) % M) != hes.end();
}



int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cerr.tie(0);
	p[0] = 1;
	for (int i = 1; i < 1e6 + 500; i++) {
		p[i] = (p[i - 1] * P) % M;
	}
	int n;
	int cd = 0;
	cin >> n;
	for (; n != 0; n--) {
		char fo;
		cin >> fo;
		cin >> s;
		s += s;
		
		vector <int> ans;
		if (fo == '?') {
			str.push_back(vector <long long>(1, 0));
			for (int i = cd; i < cd + s.size() / 2; i++) {
				str.back().push_back((str.back().back() * P + s[i]) % M);
			}
			int j = 1;
			for (int i = 1; i < str.back().size(); i++) {
				if (tac(str.size() - 1, j, i)) {
					j = i + 1;
				}
			}
			if (j + 1 == str.back().size()) {
				ans.push_back(str.size());
			}
			else {
				q[str.size() - 1] = j;
			}
		}
		else {
			long long he = 0;
			for (int i = cd; i < cd + s.size() / 2; i++) {
				he = (he * P + s[i]) % M;
			}
			hes.insert(he);
			int raz = s.size() / 2;
			for (unordered_map <int, int>::iterator it = q.begin(); it != q.end(); it++) {
				int nom = it->first;
				int pok = it->second;
				if (str[nom].size() < pok + raz) {
					continue;
				}
				if (tac(nom, pok, pok + raz - 1)) {
					pok = pok + raz;
					int j = pok;
					for (int i = 1; i < str[nom].size(); i++) {
						if (tac(str.size() - 1, j, i)) {
							j = i + 1;
						}
					}
					pok = j;
				}
				q[nom] = pok;
				if (pok == str[nom].size()) {
					ans.push_back(nom + 1);
				}
			}
		}
		cd = ans.size();
		for (int i = 0; i < ans.size(); i++) {
			q.erase(ans[i]);
		}
		cout << ans.size() << " ";
		for (int i = 0; i < ans.size(); i++) {
			cout << ans[i] << " ";
		}
		cout << endl;
	}


	
	
}