#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
#include <cstring>
#include <algorithm>
#include <cmath>

using namespace std;

struct ev{
	int x, ind, type, x2;
};

bool comp(ev a, ev b){
	if (a.x != b.x){
		return a.x < b.x;
	}
	if (a.type != b.type){
		return a.type > b.type;
	}
	return a.ind < b.ind;
}

int main(){
	int n, m, k;
	scanf("%d %d %d", &n, &m, &k);
	vector <ev> eve(2 * k);
	int co = 0;
	for (int i = 0; i < 2 * k; i += 2){
		int a, b;
		scanf("%d %d", &a, &b);
		eve[i].x = a;
		eve[i].type = 0;
		eve[i].ind = co;
		eve[i].x2 = b;
		eve[i + 1].x = b;
		eve[i + 1].ind = co;
		eve[i + 1].type = 1;
		co++;
	}
	sort(eve.begin(), eve.end(), comp);
	int bal = 0;
	vector <int> sits(m);
	for (int i = 0; i < 2 * k; i++){
		if (eve[i].type == 0){
			bal++;
			if (bal > m - 1 && bal - m < m){
				sits[bal - m] += eve[i].x2 - eve[i].x;
			}
		}
		else if (eve[i].type == 1){
			bal--;
		}
	}
	int mini = 1000000000, minind = -1;
	for (int i = 0; i < m; i++){
		if (mini > sits[i]){
			mini = sits[i];
			minind = i + 1;
		}
	}
	cout << mini << ' ' << minind;
	return 0;
}