#include <iostream>
#include <vector>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    int n, m;
    cin >> n >> m;
    vector<vector<char>> c(n, vector<char>(m));
    vector<vector<int>> u(n, vector<int>(m, -1)),
                        l(n, vector<int>(m, -1)),
                        r(n, vector<int>(m, -1)),
                        d(n, vector<int>(m, -1));
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            cin >> c[i][j];
    for (int i = 0; i < n; i++) {
        int _ = -1;
        for (int j = 1; j < m; j++) {
            if (c[i][j] != c[i][j - 1])
                _ = j - 1;
            l[i][j] = _;
        }
        _ = -1;
        for (int j = m - 2; j >= 0; j--) {
            if (c[i][j] != c[i][j + 1])
                _ = j + 1;
            r[i][j] = _;
        }
    }
    for (int j = 0; j < m; j++) {
        int _ = -1;
        for (int i = 1; i < n; i++) {
            if (c[i][j] != c[i - 1][j])
                _ = i - 1;
            u[i][j] = _;
        }
        _ = -1;
        for (int i = n - 2; i >= 0; i--) {
            if (c[i][j] != c[i + 1][j])
                _ = i + 1;
            d[i][j] = _;
        }
    }
    int q, x, y, x1, x2, y1, y2;
    cin >> q;
    for (int i = 0; i < q; i++) {
        cin >> x >> y;

        y1 = y;
        x2 = x;

        x--;
        y--;

        vector<pair<char, int>> vert;
        if (x > 0) vert.push_back({c[x - 1][y], x - 1});
        if (x < n - 1) vert.push_back({c[x + 1][y], x + 1});
        if (x > 0 && u[x - 1][y] >= 0) vert.push_back({c[u[x - 1][y]][y], u[x - 1][y]});
        if (x < n - 1 && d[x + 1][y] >= 0) vert.push_back({c[d[x + 1][y]][y], d[x + 1][y]});

        vector<pair<char, int>> horz;
        if (y > 0) horz.push_back({c[x][y - 1], y - 1});
        if (y < m - 1) horz.push_back({c[x][y + 1], y + 1});
        if (y > 0 && l[x][y - 1] >= 0) horz.push_back({c[x][l[x][y - 1]], l[x][y - 1]});
        if (y < m - 1 && r[x][y + 1] >= 0) horz.push_back({c[x][r[x][y + 1]], r[x][y + 1]});

        int ans1 = 0, ans2 = 0, dist = 1e9;
        for (auto& v: vert)
            for (auto& u: horz) {
                int ans = abs(v.second - x) + abs(u.second - y);
                if (ans < dist && u.first != v.first) {
                    dist = ans;
                    ans1 = v.second;
                    ans2 = u.second;
                }
            }
        if (dist == 1e9) {
            cout << -1 << endl;
            continue;
        }
        cout << ans1 + 1 << ' ' << y1 << ' ' << x2 << ' ' << ans2 + 1 << endl;
    }
    return 0;
}
