#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/STACK:256000000")
#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_map>

using namespace std;

typedef long long ll;
const int INF = (int)1e9 + 7;
const int MAXN = 500003;

int solve();

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 
	solve();
	return 0;
}

unordered_map<char, set<int> > stolb[MAXN], strok[MAXN];
int x, y, mini, minj, ansi1, ansi2, ansj1, ansj2, minans;
char ci, cj;

void get() {
	mini = INF, minj = INF;
	int ansjj1 = -1, ansii2 = -1;

	set<int> ::iterator itj;
	itj = strok[x][ci].upper_bound(y);
	if (itj != strok[x][ci].end()) {
		auto itbol = itj;
			if (*itbol != y && minj > abs(*itbol - y)) {
				minj = abs(*itbol - y);
				ansjj1 = *itbol;
		}
	}
	if (itj != strok[x][ci].begin()) itj--;
	if (itj != strok[x][ci].end() && (itj != strok[x][ci].begin() || *itj != y)) {
		auto itmen = itj;
		if (*itj == y) itmen--;
		if (*itmen != y && minj > abs(y - *itmen)) {
			minj = abs(y - *itmen);
			ansjj1 = *itmen;
		}
	}
	set<int> ::iterator iti;
	iti = stolb[y][cj].upper_bound(x);
	if (iti != stolb[y][cj].end()) {
		auto itbol = iti;
		if (*itbol != x && mini > abs(*itbol - x)) {
				mini = abs(*itbol - x);
				ansii2 = *itbol;
		}
	}
	if (iti != stolb[y][cj].begin()) iti--;
	if (iti != stolb[y][cj].end() && (iti != stolb[y][cj].begin() || *iti != x)) {
		auto itmen = iti;
		if (*iti == x) itmen--;
		if (*itmen != x && mini > abs(x - *itmen)) {
			mini = abs(x - *itmen);
			ansii2 = *itmen;
		}
	}
	if (mini + minj < minans) {
		ansi2 = ansii2, ansj1 = ansjj1;
		minans = mini + minj;
	}
}


int solve() {
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int n, m;
	scanf("%d%d", &n, &m);
	char c;
	scanf("%c", &c);
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			char c;
			scanf("%c", &c);
			stolb[j + 1][c].insert(i + 1);
			strok[i + 1][c].insert(j + 1);
		}
		scanf("%c", &c);
	}
	int q;
	scanf("%d", &q);

	for (int i = 0; i < q; i++) {
		scanf("%d%d", &x, &y);
		mini = INF, minj = INF;
		minans = INF;
		ansi1 = ansj1 = ansi2 = ansj2 = -1;
		for (ci = 'a'; ci <= 'z'; ci++) {
			for (cj = 'a'; cj <= 'z'; cj++) {
				if (ci == cj) {
					continue;
				}
				ansi1 = x, ansj2 = y;
				get();
			}
		}
		if (ansi1 == -1 || ansj1 == -1 || ansj2 == -1 || ansi2 == -1) printf("%d\n", -1);
		else printf("%d %d %d %d\n", ansi1, ansj1, ansi2, ansj2);
	}
	return 0;
}


