#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

int dist(int a,int b,int c ,int d)
{
    return max(a,c)-min(a,c)+max(b,d)-min(b,d);
}

int main(){
    int***l,***r,***u,***d;
    int** t;
    int n,m;
    cin >> n >> m;
    l=new int**[26];
    r=new int**[26];
    u=new int**[26];
    d=new int**[26];
    int i,j;
    for(i=0;i<26;i++){
        l[i]=new int*[n];
        r[i]=new int*[n];
        u[i]=new int*[n];
        d[i]=new int*[n];
        for(j=0;j<n;j++){
            l[i][j]=new int[m];
            r[i][j]=new int[m];
            u[i][j]=new int[m];
            d[i][j]=new int[m];
        }
    }

    t=new int*[n];
    for(i=0;i<n;i++) t[i]=new int[m];
    for(i=0;i<n;i++)
    for(j=0;j<m;j++){
        char c;
        cin >> c;
        t[i][j]=c-'a';
    }
    int k;
    for(k=0;k<26;k++){
        for(j=0;j<m;j++) u[k][0][j]=-1;
        for(i=1;i<n;i++)
            for(j=0;j<m;j++)
                if(t[i-1][j]==k) u[k][i][j]=i-1;
                else u[k][i][j]=u[k][i-1][j];

        for(i=0;i<n;i++) l[k][i][0]=-1;
        for(j=1;j<m;j++)
            for(i=0;i<n;i++)
                if(t[i][j-1]==k) l[k][i][j]=j-1;
                else l[k][i][j]=l[k][i][j-1];

        for(j=0;j<m;j++) d[k][n-1][j]=n;
        for(i=n-2;i>=0;i--)
            for(j=0;j<m;j++)
                if(t[i+1][j]==k) d[k][i][j]=i+1;
                else d[k][i][j]=d[k][i+1][j];

        for(i=0;i<n;i++) r[k][i][m-1]=m;
        for(j=m-2;j>=0;j--)
            for(i=0;i<n;i++)
                if(t[i][j+1]==k) r[k][i][j]=j+1;
                else r[k][i][j]=r[k][i][j+1];
    }
    /*for(k=0;k<3;k++){
        cout << (char)('a'+k) <<  endl;
        for(i=0;i<n;i++){
            for(j=0;j<m;j++)
                cout << u[k][i][j] << ' ';
            cout << endl;
        }
    }*/
    int q;
    cin >> q;
    for(;q>0;q--){
        int x,y;
        cin >> x >> y;
        x--;
        y--;
        int s=-1;
        int a,b,c,e;
        for(i=0;i<26;i++)
            for(j=0;j<26;j++)
            if(i!=j){
                if((u[i][x][y]!=-1)&&(l[j][x][y]!=-1)&&((s==-1)||(dist(u[i][x][y],y,x,l[j][x][y])<s))){
                        a=u[i][x][y];
                        b=y;
                        c=x;
                        e=l[j][x][y];
                        s=dist(u[i][x][y],y,x,l[j][x][y]);
                   }
                if((u[i][x][y]!=-1)&&(r[j][x][y]!=m)&&((s==-1)||(dist(u[i][x][y],y,x,r[j][x][y])<s))){
                        a=u[i][x][y];
                        b=y;
                        c=x;
                        e=r[j][x][y];
                        s=dist(u[i][x][y],y,x,r[j][x][y]);
                   }
                if((d[i][x][y]!=n)&&(l[j][x][y]!=-1)&&((s==-1)||(dist(d[i][x][y],y,x,l[j][x][y])<s))){
                        a=d[i][x][y];
                        b=y;
                        c=x;
                        e=l[j][x][y];
                        s=dist(d[i][x][y],y,x,l[j][x][y]);
                   }
                if((d[i][x][y]!=n)&&(r[j][x][y]!=m)&&((s==-1)||(dist(d[i][x][y],y,x,r[j][x][y])<s))){
                        a=d[i][x][y];
                        b=y;
                        c=x;
                        e=r[j][x][y];
                        s=dist(d[i][x][y],y,x,r[j][x][y]);
                   }
            }
        if(s!=-1) cout << a+1 << ' ' << b+1 << ' ' << c+1 << ' ' << e+1 << endl;
        else cout << -1 << endl;
    }

    return 0;
}
/*
3 4
abbb
baab
babb
4
1 1
1 4
3 1
3 4
*/
