#include <cstdlib>
#include <cstdio>
#include <iostream>
#include <algorithm>
#include <vector>

using namespace std;

inline int dist(int a,int b,int c ,int d)
{
    return max(a,c)-min(a,c)+max(b,d)-min(b,d);
}

int main(){
    int***l,***r,***u,***d,***h,***v,***_h,***_v;
    int** t;
    int n,m;
    cin >> n >> m;
    l=new int**[26];
    r=new int**[26];
    u=new int**[26];
    d=new int**[26];
    h=new int**[26];
    v=new int**[26];
    _h=new int**[26];
    _v=new int**[26];
    int i,j;
    for(i=0;i<26;i++){
        l[i]=new int*[n];
        r[i]=new int*[n];
        u[i]=new int*[n];
        d[i]=new int*[n];
        h[i]=new int*[n];
        v[i]=new int*[n];
        _h[i]=new int*[n];
        _v[i]=new int*[n];
        for(j=0;j<n;j++){
            l[i][j]=new int[m];
            r[i][j]=new int[m];
            u[i][j]=new int[m];
            d[i][j]=new int[m];
            h[i][j]=new int[m];
            v[i][j]=new int[m];
            _h[i][j]=new int[m];
            _v[i][j]=new int[m];
        }
    }

    t=new int*[n];
    for(i=0;i<n;i++) t[i]=new int[m];
    getchar();
    string str;
    for(i=0;i<n;i++){
        getline(cin,str);
        for(j=0;j<m;j++)
            t[i][j]=str[j]-'a';
    }
    int k;
    int inf=1000000000;
    for(k=0;k<26;k++){
        for(j=0;j<m;j++) u[k][0][j]=inf;
        for(i=1;i<n;i++)
            for(j=0;j<m;j++)
                if(t[i-1][j]==k) u[k][i][j]=1;
                else u[k][i][j]=u[k][i-1][j]+1;

        for(i=0;i<n;i++) l[k][i][0]=inf;
        for(j=1;j<m;j++)
            for(i=0;i<n;i++)
                if(t[i][j-1]==k) l[k][i][j]=1;
                else l[k][i][j]=l[k][i][j-1]+1;

        for(j=0;j<m;j++) d[k][n-1][j]=inf;
        for(i=n-2;i>=0;i--)
            for(j=0;j<m;j++)
                if(t[i+1][j]==k) d[k][i][j]=1;
                else d[k][i][j]=d[k][i+1][j]+1;

        for(i=0;i<n;i++) r[k][i][m-1]=inf;
        for(j=m-2;j>=0;j--)
            for(i=0;i<n;i++)
                if(t[i][j+1]==k) r[k][i][j]=1;
                else r[k][i][j]=r[k][i][j+1]+1;
    }

    for(k=0;k<26;k++)
        for(i=0;i<n;i++)
            for(j=0;j<m;j++){
                if(l[k][i][j]<r[k][i][j]) h[k][i][j]=j-l[k][i][j];
                else h[k][i][j]=j+r[k][i][j];
                if(u[k][i][k]<d[k][i][j]) v[k][i][j]=i-u[k][i][j];
                else v[k][i][j]=i+d[k][i][j];
    }
   /* for(k=0;k<3;k++){
        cout << (char)('a'+k) <<  endl;
        for(i=0;i<n;i++){
            for(j=0;j<m;j++)
                cout << r[k][i][j] << ' ';
            cout << endl;
        }
    }*/
    int q;
    int x,y;
    int s;
    int a,e;
    int f;
    cin >> q;
    for(;q>0;q--){
        scanf("%d%d",&x,&y);
        x--;
        y--;
        s=-1;
        for(i=0;i<26;i++)
            for(j=0;j<26;j++)
            if(i!=j){
                if((v[i][x][y]>=0)&&(v[i][x][y]<n)&&(h[j][x][y]>=0)&&(h[j][x][y]<m)&&((s==-1)||(dist(v[i][x][y],y,x,h[j][x][y])<s))){
                        a=v[i][x][y];
                        e=h[j][x][y];
                        s=dist(v[i][x][y],y,x,h[j][x][y]);
                   }
            }
        if(s!=-1) cout << a+1 << ' ' << y+1 << ' ' << x+1 << ' ' << e+1 << "\n";
        else cout << -1 << "\n";
    }

    return 0;
}
/*
3 4
abbb
baab
babb
4
1 1
1 4
3 1
3 4
*/
