#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <queue>

using namespace std;

vector <string> v;
int n, m, q;

int main(){
	cin >> n >> m;
	v.resize(n);
	for (int i = 0; i < n; i++) cin >> v[i];
	cin >> q;
	for (int i = 0; i < q; i++){
		int x1, y2, x2, y1, mi = n * m;
		bool flag = false;
		cin >> x1 >> y2;
		x1--; y2--;
		vector <bool> used(26), usedc(m);
		queue<int> cq;
		cq.push(y2);
		while (cq.size() > 0){
			int c = cq.front();
			cq.pop();
			if (c + 1 < m && !usedc[c + 1]) cq.push(c + 1);
			if (c > 0 && !usedc[c - 1]) cq.push(c - 1);
			if (c != y2 && !used[v[x1][c] - 'a']){
				queue<int> rq;
				rq.push(x1);
				vector <bool> usedr(n);
				while(rq.size() > 0){
					int r = rq.front();
					rq.pop();
					if (r + 1 < n && !usedr[r + 1]) rq.push(r + 1);
					if (r > 0 && !usedr[r - 1]) rq.push(r - 1);
					if (v[x1][c] != v[r][y2] && r != x1 && abs(x1 - r) + abs(c - y2) < mi){
						y1 = c;
						x2 = r;
						mi = abs(x1 - r) + abs(c - y2);
						flag = true;
						break;
					}
					usedr[r] = true;
				}
				used[v[x1][c] - 'a'] = true;
			}
			usedc[c] = true;
		}
		if (flag) cout << x1 + 1 << " " << y1 + 1 << " " << x2 + 1 << " " << y2 + 1 << endl;
		else cout << -1 << endl;
	}
	system("pause");
	return 0;
}