#include <iostream>
#include <cmath>

using namespace std;

typedef long long ll;

int count(ll x) {
	int cnt = 0;

	for (ll i = 1; i <= sqrt(x); i++) {
		if ((x % i) == 0) {
			cnt++;
			if ((x / i) != i) {
				cnt++;
            }
        }
	}

	return cnt;
}

int main() {
	ll x;

	cin >> x;

	if (x > 1e11) {
		for (ll y = x + (x % 2); y <= x / 100 * 101; y += 2) {
			if (count(y) >= 100) {
				cout << y << '\n';
				return 0;
			}
		}

		cout << "-1\n";
		return 0;
    }

	for (ll y = x; y <= x / 100 * 101, x; y++) {
		if (count(y) >= 100) {
			cout << y << '\n';
			return 0;
        }
    }
	
	cout << "-1\n";

	return 0;
}
