#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <ctime>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
       
typedef long long ll;
       
const ll INF = (ll)1e9;
   
class event {
public:
    ll x, type, id;
};
   
bool operator<(event a, event b) {
    return a.x < b.x || (a.x == b.x && (a.type < b.type || (a.type == b.type && a.id < b.id)));
}
   
int main(void) {
    ll n, m, k;
    scanf("%lld%lld%lld", &n, &m, &k);
    std::vector<event> a;
    std::vector<std::pair<ll, ll>> inp;
    for (ll i = 0; i < k; ++i) {
        ll f, s;
        scanf("%lld%lld", &f, &s);
        a.push_back({f, 1, i});
        a.push_back({s, -1, i});
        inp.push_back({f, s});
    }
    std::sort(a.begin(), a.end());
    ll cnt = 0, cnt2 = 0;
    std::vector<ll> cur(m), used(k);
    std::set<ll> q;
    for (ll i = 1; i <= m; ++i) {
        q.insert(i);
    }
    for (ll i = 0; i < a.size(); ++i) {
        if (a[i].type == 1) {
            if (cnt < m - 1) {
                ++cnt;
                used[a[i].id] = -1;
            } else if (cnt2 < m) {
                ++cnt2;
                used[a[i].id] = *q.begin();
                cur[(*q.begin()) - 1] += inp[a[i].id].second - inp[a[i].id].first;
                q.erase(q.begin());
            }
        } else {
            if (used[a[i].id] == -1) {
                --cnt;
            } else if (used[a[i].id] > 0) {
                --cnt2;
                q.insert(used[a[i].id]);
            }
            used[a[i].id] = 0;
        }
    }
    ll index = 0;
    for (ll i = 0; i < m; ++i) {
        if (cur[i] < cur[index]) {
            index = i;
        }
    }
    printf("%lld %lld\n", cur[index], index + 1);
    return 0;
}