#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    int n, m, k; cin >> n >> m >> k;
    vector < pair <int, int> > pass(2 * k);
    vector < pair <int, int> > events;
    int freeSit = m - 1;
    set <int> freeStand;
    vector <int> standCount(m);
    vector <int> passWhere(k);
    for (int i = 0; i < m; i++)
        freeStand.insert(i);
    for (int i = 0; i < k; i++) {
        cin >> pass[i].first >> pass[i].second;
        events.emplace_back(pass[i].first, +(i + 1));
        events.emplace_back(pass[i].second, -(i + 1));
    }
    sort(events.begin(), events.end());
    for (int i = 0; i < (int)events.size(); i++) {
        int id = abs(events[i].second) - 1;
        if (events[i].second < 0) {
            if (passWhere[id] >= 0) {
                standCount[passWhere[id]] += pass[id].second - pass[id].first;
                freeStand.insert(passWhere[id]);
            } else if (passWhere[id] == -1) {
                freeSit++;
            }
        } else {
            if (freeSit == 0) {
                if (!freeStand.empty()) {
                    passWhere[id] = *freeStand.begin();
                    freeStand.erase(freeStand.begin());
                } else {
                    passWhere[id] = -2;
                }
            } else {
                passWhere[id] = -1;
                freeSit--;
            }
        }
    }
    int ans = 0;
    for (int i = 1; i < m; i++)
        if (standCount[i] < standCount[ans])
            ans = i;
    cout << standCount[ans] << " " << ans+1 << endl;
    return 0;
}
