#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int n, m;
vector <string> v;
vector < vector <int> > lettersRow[26];
int lrr[26][1000000];
vector < vector <int> > noletCol[26];
int ncr[26][1000000];

inline int nearest(const vector <int>& v, int x) {
    int ans = -123456789;
    int l1 = (int)(lower_bound(v.begin(), v.end(), x) - v.begin());
    int l0 = l1 - 1;
    int l2 = l1 + 1;
    if (0 <= l0 && l0 < (int)v.size())
        if (x != v[l0] && abs(x - v[l0]) < abs(x - ans))
            ans = v[l0];
    if (0 <= l1 && l1 < (int)v.size())
        if (x != v[l1] && abs(x - v[l1]) < abs(x - ans))
            ans = v[l1];
    if (0 <= l2 && l2 < (int)v.size())
        if (x != v[l2] && abs(x - v[l2]) < abs(x - ans))
            ans = v[l2];
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin >> n >> m;
    v.resize(n);
    for (int i = 0; i < 26; i++) {
        lettersRow[i].resize(n);
        noletCol[i].resize(m);
    }
    for (int i = 0; i < n; i++)
        cin >> v[i];
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            for (int k = 0; k < 26; k++)
                if (v[i][j] == k + 'a') {
                    lrr[k][i]++;
                } else {
                    ncr[k][j]++;
                }
    for (int i = 0; i < n; i++)
        for (int k = 0; k < 26; k++)
            lettersRow[k][i].reserve(lrr[k][i]);
    for (int j = 0; j < m; j++)
        for (int k = 0; k < 26; k++)
            noletCol[k][j].reserve(ncr[k][j]);
    for (int i = 0; i < n; i++)
        for (int j = 0; j < m; j++)
            for (int k = 0; k < 26; k++)
                if (v[i][j] == k + 'a') {
                    lettersRow[k][i].push_back(j);
                } else {
                    noletCol[k][j].push_back(i);
                }
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        int a, b; cin >> a >> b; a--, b--;
        int ax = -1, ay = -1, ansC = 2345678;
        for (int k = 0; k < 26; k++) {
            int q1 = nearest(lettersRow[k][a], b);
            int q2 = nearest(noletCol[k][b], a);
            int tmp = abs(q1 - b) + abs(q2 - a);
            if (tmp < ansC) {
                ax = q1;
                ay = q2;
                ansC = tmp;
            }
        }
        if (ax < 0 || ay < 0) {
            cout << -1;
        } else {
            cout << a+1 << " " << ax+1 << " " << ay+1 << " " << b+1;
        }
        cout << "\n";
    }
    return 0;
}
