#include <bits/stdc++.h>
#define mp make_pair
#define pb push_back
using namespace std;
const int N = 2e5;
const int M = 5e5;
int n, m;
int inf = 1e9;
vector <string> v;
vector <vector <int> > prefw[26];
vector <vector <int> > prefh[26];
vector <vector <int> > lw[26];
vector <vector <int> > lh[26];
vector <vector <int> > rw[26];
vector <vector <int> > rh[26];
vector <vector <pair <pair <int, int>, pair <int, int> > > > res;
int bin1(int i, int l, int r, int k, int st) {
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (prefw[k][i][m + 1] - prefw[k][i][st] == 0) l = m;
        else r = m;
    }
    if (r <= l + 1) {
        if (r <= l) return inf;
        if (v[i][r] - 'a' == k) return r;
        else return inf;
    }
}
int bin2(int i, int l, int r, int k, int st) {
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (prefw[k][i][st + 1] - prefw[k][i][m] == 0) r = m;
        else l = m;
    }
    if (r <= l + 1) {
        if (r <= l) return -inf;
        if (v[i][l] - 'a' == k) return l;
        else return -inf;
    }
}
int bin3(int i, int l, int r, int k, int st) {
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (prefh[k][i][m + 1] - prefh[k][i][st] == m + 1 - st) l = m;
        else r = m;
    }
    if (r <= l + 1) {
        if (r <= l) return inf;
        if (v[r][i] - 'a' != k) return r;
        else return inf;
    }
}
int bin4(int i, int l, int r, int k, int st) {
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (prefh[k][i][st + 1] - prefh[k][i][m] == st + 1 - m) r = m;
        else l = m;
    }
    if (r <= l + 1) {
        if (r <= l) return -inf;
        if (v[l][i] - 'a' != k) return l;
        else return -inf;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    scanf("%d%d", &n, &m);
    res.resize(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) res[i].pb(mp(mp(-2, -1), mp(-1, -1)));
    }
    char c;
    scanf("%c", &c);
    v.resize(n);
    for (int i = 0; i < n; i++) {
        v[i].resize(m);
        for (int j = 0; j < m; j++) {
                scanf("%c", &v[i][j]);
        }
        scanf("%c", &c);
    }
    for (int i = 0; i < 26; i++) {
        prefw[i].resize(n);
        prefh[i].resize(m);
    }
    for (int i = 0; i < n; i++) {
        for (int k = 0; k < 26; k++) prefw[k][i].pb(0);
        for (int j = 0; j < m; j++) {
            for (int k = 0; k < 26; k++) prefw[k][i].pb(prefw[k][i][j]);
            prefw[v[i][j] - 'a'][i][j + 1]++;
        }
    }
    for (int i = 0; i < m; i++) {
        for (int k = 0; k < 26; k++) prefh[k][i].pb(0);
        for (int j = 0; j < n; j++) {
            for (int k = 0; k < 26; k++) prefh[k][i].pb(prefh[k][i][j]);
            prefh[v[j][i] - 'a'][i][j + 1]++;
        }
    }
    for (int k = 0; k < 26; k++) {
        lw[k].resize(n);
        rw[k].resize(n);
        for (int i = 0; i < n; i++) {
            lw[k][i].resize(m);
            rw[k][i].resize(m);
        }
        lh[k].resize(m);
        rh[k].resize(m);
        for (int i = 0; i < m; i++) {
            lh[k][i].resize(n);
            rh[k][i].resize(n);
        }
    }
    for (int k = 0; k < 26; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                    lw[k][i][j] = lh[k][i][j] = -inf;
                    rw[k][i][j] = rh[k][i][j] = inf;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            for (int k = j + 1; k < m; k++) {
                lw[v[i][j] - 'a'][i][k] = j;
                if (v[i][k] == v[i][j]) break;
            }
            for (int k = j - 1; k >= 0; k--) {
                rw[v[i][j] - 'a'][i][k] = j;
                if (v[i][k] == v[i][j]) break;
            }
            for (int k = i + 1; k < n; k++) {
                lh[v[i][j] - 'a'][k][j] = i;
                if (v[k][j] != v[i][j]) break;
            }
            for (int k = i - 1; k >= 0; k--) {
                rh[v[i][j] - 'a'][k][j] = i;
                if (v[k][j] != v[i][j]) break;
            }
        }
    }
    vector <pair <pair <int, int>, pair <int, int> > > ans;
    int q;
    scanf("%d", &q);
    for (int k = 0; k < q; k++) {
        int x, y;
        scanf("%d%d", &x, &y);
        x--;
        y--;
        if (res[x][y].first.first != -2) {
            ans.pb(res[x][y]);
            continue;
        }
        int mn = inf, a, b;
        for (int k = 0; k < 26; k++) {
            int jl = -inf, jr = inf;
            jr = rw[k][x][y];//bin1(x, y, m - 1, k, y + 1);
            jl = lw[k][x][y];//bin2(x, 0, y, k, y - 1);
            int j;
            if (jr - y <= y - jl) j = jr;
            else j = jl;
            int il = -inf, ir = inf;
            ir = bin3(y, x, n - 1, k, x + 1);
            il = bin4(y, 0, x, k, x - 1);
            int i;
            if (ir - x <= x - il) i = ir;
            else i = il;
            if (i < 0 || i >= n || j < 0 || j >= m) continue;
            if (abs(i - x) + abs(j - y) < mn) {
                mn = abs(i - x) + abs(j - y);
                a = i;
                b = j;
            }
        }
        if (mn == inf) ans.pb(mp(mp(-1, -1), mp(-1, -1)));
        else ans.pb(mp(mp(x + 1, b + 1), mp(a + 1, y + 1)));
        res[x][y] = ans[ans.size() - 1];
    }
    for (int i = 0; i < q; i++) {
        if (ans[i].first.first == -1) printf("-1\n");//cout << -1 << endl;
        else printf("%d %d %d %d\n", ans[i].first.first, ans[i].first.second, ans[i].second.first, ans[i].second.second);//cout << ans[i].first.first << " " << ans[i].first.second << " " << ans[i].second.first << " " << ans[i].second.second << endl;
    }
}
