#include <string>
#include <iostream>
#include <vector>
#include <algorithm>
#include <fstream>
#include <string>

using namespace std;

struct node
{
	int go['z' - 'a' + 1];
	vector<int> wgo['z' - 'a' + 1];
	node()
	{
		fill(go, go + 'z' - 'a' + 1, -1);
		fill(wgo, wgo + 'z' - 'a' + 1, vector<int>(0));
	}
};

vector<node> aut(1);
vector<int> lb;
vector<int> ap;
vector<string> b;
int ans = 0;

vector<int> out;



int push(int w)
{
	for (; lb[w] < b[w].length(); lb[w]++)
	{
		if (aut[ap[w]].go[-'a'  + b[w][lb[w]]] == -1)
		{
			aut[ap[w]].wgo[-'a'  + b[w][lb[w]]].push_back(w);
			return 0;
		}
		ap[w] = aut[ap[w]].go[-'a'  + b[w][lb[w]]];
	}
	if (ap[w] == 0)
	{
		out.push_back(w);
		return 1;
	}
	return 0;
}

int add_g(string s)
{
	int p = 0;
	vector<int> to_p;
	char lc = s.back();
	s.pop_back();
	for (char c : s)
	{
		if (aut[p].go[-'a'  + c] == -1)
		{
			for (int u : aut[p].wgo[-'a'  + c])
				to_p.push_back(u);
			aut[p].go[-'a'  + c] = aut.size();
			aut.push_back(node());
		}
		p = aut[p].go[-'a'  + c];
	}
	if (aut[p].go[-'a'  + lc] == -1)
	{
		for (int u : aut[p].wgo[-'a'  + lc])
			to_p.push_back(u);
	}
	aut[p].go[-'a'  + lc] = 0;
	for (int i : to_p)
		ans += push(i);
	return ans;
}

int add_s(string s)
{
	int idx = b.size();
	b.push_back(s);
	lb.push_back(0);
	ap.push_back(0);
	return ans += push(idx);
}

int kek = 0;

string form(string s)
{
	int move = kek % s.length();
	return s.substr(move, s.length() - move) + s.substr(0, move);
}

int main()
{
	ios::sync_with_stdio(0);
	ifstream cin("TEST.txt");
	int n;
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		//cerr << i << "\n";
		char c;
		cin >> c;
		string s;
		cin >> s;
		s = form(s);
		if (c == '?')
			add_s(s);
		else
			add_g(s);
		cout << (kek = out.size()) << " ";
		for (int u : out)
			cout << u + 1 << " ";
		out.clear();
		cout << "\n";
	}
	return 0;
}