#include <iostream>

using namespace std;

typedef long long ll;

ll numDiv(ll n) {
	ll res = 1;
	ll cres = 1;
	ll cd = 1;
	for (int d = 2; d * d <= n || d == n;) {
		if (n % d) {
			res *= cres;
			cres = 1;
			++d;
			continue;
		}
		if (cd != d) {
			res *= cres;
			cres = 2;
			cd = d;
		} else {
			++cres;
		}
		n /= d;
	}
	res *= cres;
	if (n != 1) res *= 2;
	return res;
}

int main() {
	ll d = 16 * 9 * 5 * 7 * 11;
	ll n;
	cin >> n;
	ll m = n + n / 100;
	if (m / d != (n - 1) / d) {
		cout << m - (m % d) << '\n';
		return 0;
	}
	for (int i = n; i <= m; ++i) {
		//cout << i << ' ' << numDiv(i) << '\n';
		if (numDiv(i) >= 100) {
			cout << i << '\n';
			return 0;
		}
	}
	cout << "-1\n";
	//int nqw = 0;
	//while (true) ++nqw;
	//cout << nqw << '\n';
}